unit GetCharDlg;

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Grids,SysUtils;

type
  TASCIICharDlg = class(TForm)
    Panel2: TPanel;
    Panel1: TPanel;
    SelectDis: TLabel;
    Panel3: TPanel;
    AsciiGrid: TDrawGrid;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    procedure AsciiGridDrawCell(Sender: TObject; Col, Row: integer;
      Rect: TRect; State: TGridDrawState);
    procedure AsciiGridSelectCell(Sender: TObject; Col, Row: integer;
      var CanSelect: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ASCIICharDlg: TASCIICharDlg;

function ChooseASCIIChar(F: TFont; var C: byte): boolean;


implementation


{$R *.DFM}



var WorkFont: TFont;


procedure SetFont(F: TFont);
var S1,S2: integer;
begin
WorkFont:=F;
WorkFont.Color:=clBlack;
S1:=F.Size+4;
S2:=(ASCIICharDlg.AsciiGrid.Font.Size * 3) +4;
if S2>S1 then S1:=S2;
ASCIICharDlg.AsciiGrid.DefaultColWidth:=S1;
ASCIICharDlg.AsciiGrid.DefaultRowHeight:=S1;
end;



procedure DrawString(R: TRect;S:String);
begin
ASCIICharDlg.AsciiGrid.Canvas.TextRect(R,R.Left+2,R.Top+2,S);
end;

procedure TASCIICharDlg.AsciiGridDrawCell(Sender: TObject; Col, Row: integer;
  Rect: TRect; State: TGridDrawState);
var C: char;
begin
if (Row=0) and (Col=0) then DrawString(Rect,'#')
else if (Row=0) and (Col<>0) then DrawString(Rect,'$'+IntToHex((Col-1)*16,2))
else if (Row<>0) and (Col=0) then DrawString(Rect,'$'+IntToHex(Row-1,2))
else
	begin
	if gdSelected in State then AsciiGrid.Canvas.Brush.Color:=clSilver
	else AsciiGrid.Canvas.Brush.Color:=clWhite;
	AsciiGrid.Canvas.FillRect(Rect);
	AsciiGrid.Canvas.Font:=WorkFont;
	C:=char((Row-1)+((Col-1)*16));
	DrawString(Rect,C);
	end;
end;

procedure TASCIICharDlg.AsciiGridSelectCell(Sender: TObject; Col, Row: integer;
  var CanSelect: Boolean);
var V: integer;
begin
V:=(Row-1)+((Col-1)*16);
SelectDis.Caption:='$'+IntToHex(V,2);
end;

procedure SetCursorPos(B: byte);
var Row,Col: integer;
begin
{Note: display layout for ASCII backwards}
{Columns increment by 16, rows by 1}
Col:=B div 16; Row:=B mod 16;
ASCIICharDlg.AsciiGrid.Row:=Row+1;
ASCIICharDlg.AsciiGrid.Col:=Col+1;
ASCIICharDlg.AsciiGrid.TopRow:=Row+1;
end;


function ChooseASCIIChar(F: TFont; var C: byte): boolean;
begin
SetFont(F);
SetCursorPos(C);
ASCIICharDlg.ShowModal;
Result:=ASCIICharDlg.ModalResult=mrOK;
if Result then
	begin
	C:=(ASCIICharDlg.AsciiGrid.Row-1)+((ASCIICharDlg.AsciiGrid.Col-1)*16);
	end;
end;

end.
