unit ComplexLib;

interface

uses SysUtils,DSupport;


type TComplexNumber = record
  Real,Imag: double;
 end;

function ComplexAdd(C1,C2: TComplexNumber): TComplexNumber; overload;
function ComplexAdd(C: TComplexNumber; S: double): TComplexNumber; overload;

function ComplexSubtract(C1,C2: TComplexNumber): TComplexNumber; overload;
function ComplexSubtract(C: TComplexNumber; S: double): TComplexNumber; overload;

function ComplexMultiply(C1,C2: TComplexNumber): TComplexNumber; overload;
function ComplexMultiply(C: TComplexNumber; S: double): TComplexNumber; overload;

function ComplexDivide(C1,C2: TComplexNumber): TComplexNumber; overload;
function ComplexDivide(C: TComplexNumber; S: double): TComplexNumber; overload;

function ComplexSquare(C: TComplexNumber): TComplexNumber;
function ComplexNegate(C: TComplexNumber): TComplexNumber;

function MakeComplex(Real,Imag: double): TComplexNumber;
function GetComplexStr(C: TComplexNumber; Labeled: boolean; Digits: integer): string;


implementation


function GetComplexStr(C: TComplexNumber; Labeled: boolean; Digits: integer): string;
begin
Result:=PickString(Labeled,'R: ','');
Result:=Result+FloatToStrF(C.Real,ffFixed,18,Digits);
Result:=Result+PickString(Labeled,'I: ','');
Result:=Result+FloatToStrF(C.Imag,ffFixed,18,Digits);
end;



function ComplexSubtract(C1,C2: TComplexNumber): TComplexNumber;
begin
Result.Real:=C1.Real - C2.Real;
Result.Imag:=C1.Imag - C2.Imag;
end;



function ComplexSubtract(C: TComplexNumber; S: double): TComplexNumber;
begin
Result.Real:=C.Real - S;
Result.Imag:=C.Imag - S;
end;


function ComplexAdd(C1,C2: TComplexNumber): TComplexNumber;
begin
Result.Real:=C1.Real + C2.Real;
Result.Imag:=C1.Imag + C2.Imag;
end;



function ComplexAdd(C: TComplexNumber; S: double): TComplexNumber;
begin
Result.Real:=C.Real + S;
Result.Imag:=C.Imag + S;
end;




function ComplexSquare(C: TComplexNumber): TComplexNumber;
{Square optimized}
begin
Result.Imag:=2 * C.Imag * C.Real;
Result.Real:=Sqr(C.Real) - Sqr(C.Imag);
end;


function ComplexMultiply(C1,C2: TComplexNumber): TComplexNumber;
begin
Result.Real:=(C1.Real * C2.Real) - (C1.Imag * C2.Imag);
Result.Imag:=(C1.Real * C2.Imag) + (C2.Real * C1.Imag);
end;



function ComplexMultiply(C: TComplexNumber; S: double): TComplexNumber;
begin
Result.Real:=C.Real * S;
Result.Imag:=C.Imag * S;
end;




function ComplexDivide(C1,C2: TComplexNumber): TComplexNumber;
var D: double;
begin
D:=Sqr(C2.Real) + Sqr(C2.Imag);
Result.Real:=(C1.Real*C2.Real+C1.Imag*C2.Imag)/D;
Result.Imag:=(C1.Imag*C2.Real-C1.Real*C2.Imag)/D;
end;



function ComplexDivide(C: TComplexNumber; S: double): TComplexNumber;
begin
Result.Real:=C.Real / S;
Result.Imag:=C.Imag / S;
end;



function ComplexNegate(C: TComplexNumber): TComplexNumber;
begin
Result.Real:=-C.Real;
Result.Imag:=-C.Imag;
end;




function MakeComplex(Real,Imag: double): TComplexNumber;
begin
Result.Real:=Real;
Result.Imag:=Imag;
end;

end.
