unit DepthColors;

interface

uses Windows,Graphics,BitmapLib,Vector;

{ Gradient arrays }

type TGradientType = (gtRGB,gtHSV);

type TGradientItem = record
 C1,C2: TColor;
 Percent1,Percent2: double;
 GradType: TGradientType;
 end;

type TGradientArray = array of TGradientItem;

function GetGradientColor(A: array of TGradientItem; Percent: double): TColor;


const TerrainMap: array [0..1] of TGradientItem = (
 (C1: 46 or (154 shl 8) or (88 shl 16); C2: 200 or (55 shl 8) or (55 shl 16); Percent1: 0; Percent2: 0.90; GradType: gtHSV),
 (C1: 200 or (55 shl 8) or (55 shl 16); C2: 215 or (244 shl 8) or (244 shl 16); Percent1: 0.90; Percent2: 1.00; GradType: gtRGB)
 );




{Static color arrays}

type TDepthArray = array of TColor;

type TColorDepth=(dc12,dc20,dc24,dc30,dcTemp32);


const DepthColors13: array [0..12] of TColor =(
	0 or (0 shl 8) or (0 shl 16),
	128 or (0 shl 8) or (0 shl 16),
	255 or (0 shl 8) or (0 shl 16),
	255 or (255 shl 8) or (0 shl 16),
	128 or (128 shl 8) or (0 shl 16),
	0 or (255 shl 8) or (0 shl 16),
	0 or (128 shl 8) or (0 shl 16),
	0 or (128 shl 8) or (128 shl 16),
	0 or (255 shl 8) or (255 shl 16),
	0 or (0 shl 8) or (255 shl 16),
	0 or (0 shl 8) or (128 shl 16),
	128 or (0 shl 8) or (128 shl 16),
	255 or (0 shl 8) or (255 shl 16));


const DepthColors24: array [0..23] of TColor =(
	  0 or   (0 shl 8) or   (0 shl 16),
	255 or   (0 shl 8) or   (0 shl 16),
	255 or  (63 shl 8) or   (0 shl 16),
	255 or (127 shl 8) or   (0 shl 16),
	255 or (191 shl 8) or   (0 shl 16),
	255 or (255 shl 8) or   (0 shl 16),
	191 or (255 shl 8) or   (0 shl 16),
	127 or (255 shl 8) or   (0 shl 16),
	 63 or (255 shl 8) or   (0 shl 16),
	  0 or (255 shl 8) or   (0 shl 16),
	  0 or (255 shl 8) or  (63 shl 16),
	  0 or (255 shl 8) or (127 shl 16),
	  0 or (255 shl 8) or (191 shl 16),
	  0 or (255 shl 8) or (255 shl 16),
	  0 or (191 shl 8) or (255 shl 16),
	  0 or (127 shl 8) or (255 shl 16),
	  0 or  (63 shl 8) or (255 shl 16),
	  0 or   (0 shl 8) or (255 shl 16),
	 63 or   (0 shl 8) or (255 shl 16),
	127 or   (0 shl 8) or (255 shl 16),
	191 or   (0 shl 8) or (255 shl 16),
	255 or   (0 shl 8) or (255 shl 16),
	255 or   (0 shl 8) or (191 shl 16),
	255 or   (0 shl 8) or (127 shl 16));


const Geocolors30: array [0..29] of TColor =(
	  0 or   (0 shl 8) or   (0 shl 16),
	255 or   (255 shl 8) or (255 shl 16),
	208 or   (208 shl 8) or (208 shl 16),
	191 or   (191 shl 8) or (191 shl 16),
	160 or   (160 shl 8) or (160 shl 16),
	128 or   (128 shl 8) or (128 shl 16),
	208 or   (64 shl 8) or (208 shl 16),
	255 or   (0 shl 8) or (255 shl 16),
	208 or   (0 shl 8) or (208 shl 16),
	128 or   (0 shl 8) or (128 shl 16),
	208 or   (0 shl 8) or (64 shl 16),
	255 or   (0 shl 8) or   (0 shl 16),
	255 or  (63 shl 8) or   (0 shl 16),
	255 or (127 shl 8) or   (0 shl 16),
	255 or (191 shl 8) or   (0 shl 16),
	255 or (255 shl 8) or   (0 shl 16),
	191 or (255 shl 8) or   (0 shl 16),
	127 or (255 shl 8) or   (0 shl 16),
	 63 or (255 shl 8) or   (0 shl 16),
	  0 or (255 shl 8) or   (0 shl 16),
	  0 or (255 shl 8) or  (63 shl 16),
	  0 or (255 shl 8) or (127 shl 16),
	  0 or (255 shl 8) or (191 shl 16),
	  0 or (255 shl 8) or (255 shl 16),
	  0 or (191 shl 8) or (255 shl 16),
	  0 or (127 shl 8) or (255 shl 16),
	  0 or  (63 shl 8) or (255 shl 16),
	  0 or   (0 shl 8) or (255 shl 16),
	  0 or   (0 shl 8) or (208 shl 16),
	  0 or   (0 shl 8) or (128 shl 16));

const Geocolors20: array [0..19] of TColor =(
	  0 or   (0 shl 8) or   (0 shl 16),
	255 or   (255 shl 8) or (255 shl 16),
	191 or   (191 shl 8) or (191 shl 16),
	160 or   (160 shl 8) or (160 shl 16),
	191 or   (128 shl 8) or (191 shl 16),
	208 or   (0 shl 8) or (208 shl 16),
	208 or   (0 shl 8) or (160 shl 16),  
	255 or   (0 shl 8) or   (0 shl 16),
	255 or  (127 shl 8) or   (0 shl 16),
	255 or (191 shl 8) or   (0 shl 16),
	255 or (255 shl 8) or   (0 shl 16),
	191 or (255 shl 8) or   (0 shl 16),
	 127 or (255 shl 8) or   (0 shl 16),
	  0 or (255 shl 8) or  (63 shl 16),
	  0 or (255 shl 8) or (191 shl 16),
	  0 or (255 shl 8) or (255 shl 16),
	  0 or (191 shl 8) or (255 shl 16),
	  0 or  (127 shl 8) or (255 shl 16),
	  0 or   (0 shl 8) or (208 shl 16),
	  0 or   (0 shl 8) or (128 shl 16));


const ColorTemp32: array [0..32] of TColor =(
	  0 or (0 shl 8) or (0 shl 16),
	255 or (240 shl 8) or (0 shl 16),
	255 or (224 shl 8) or (0 shl 16),
	255 or (208 shl 8) or (0 shl 16),
	255 or (192 shl 8) or (0 shl 16),
	255 or (176 shl 8) or (0 shl 16),
	255 or (160 shl 8) or (0 shl 16),
	255 or (144 shl 8) or (0 shl 16),
	255 or (128 shl 8) or (0 shl 16),
	255 or (112 shl 8) or (0 shl 16),
	255 or (96 shl 8) or (0 shl 16),
	255 or (80 shl 8) or (0 shl 16),
	255 or (64 shl 8) or (0 shl 16),
	255 or (48 shl 8) or (0 shl 16),
	255 or (32 shl 8) or (0 shl 16),
	255 or (16 shl 8) or (0 shl 16),
	255 or (0 shl 8) or (0 shl 16),
	240 or (0 shl 8) or (0 shl 16),
	224 or (0 shl 8) or (0 shl 16),
	208 or (0 shl 8) or (0 shl 16),
	192 or (0 shl 8) or (0 shl 16),
	176 or (0 shl 8) or (0 shl 16),
	160 or (0 shl 8) or (0 shl 16),
	144 or (0 shl 8) or (0 shl 16),
	128 or (0 shl 8) or (0 shl 16),
	112 or (0 shl 8) or (0 shl 16),
	96 or (0 shl 8) or (0 shl 16),
	80 or (0 shl 8) or (0 shl 16),
	64 or (0 shl 8) or (0 shl 16),
	48 or (0 shl 8) or (0 shl 16),
	32 or (0 shl 8) or (0 shl 16),
	16 or (0 shl 8) or (0 shl 16),
	0 or  (0 shl 8) or (0 shl 16));

const ColorMap47: array [0..46] of TColor = (
	0 or (0 shl 8) or (0 shl 16),
	255 or (255 shl 8) or (255 shl 16),
	255 or (212 shl 8) or (212 shl 16),
	255 or (169 shl 8) or (169 shl 16),
	255 or (127 shl 8) or (127 shl 16),
	255 or (84 shl 8) or (84 shl 16),
	255 or (42 shl 8) or (42 shl 16),
	255 or (0 shl 8) or (0 shl 16),
	255 or (13 shl 8) or (0 shl 16),
	255 or (26 shl 8) or (0 shl 16),
	255 or (40 shl 8) or (0 shl 16),
	255 or (53 shl 8) or (0 shl 16),
	255 or (67 shl 8) or (0 shl 16),
	255 or (80 shl 8) or (0 shl 16),
	255 or (93 shl 8) or (0 shl 16),
	255 or (107 shl 8) or (0 shl 16),
	255 or (120 shl 8) or (0 shl 16),
	255 or (134 shl 8) or (0 shl 16),
	255 or (147 shl 8) or (0 shl 16),
	255 or (161 shl 8) or (0 shl 16),
	255 or (174 shl 8) or (0 shl 16),
	255 or (187 shl 8) or (0 shl 16),
	255 or (201 shl 8) or (0 shl 16),
	255 or (214 shl 8) or (0 shl 16),
	255 or (228 shl 8) or (0 shl 16),
	255 or (241 shl 8) or (0 shl 16),
	255 or (255 shl 8) or (0 shl 16),
	236 or (248 shl 8) or (0 shl 16),
	218 or (242 shl 8) or (0 shl 16),
	200 or (235 shl 8) or (0 shl 16),
	183 or (229 shl 8) or (0 shl 16),
	167 or (223 shl 8) or (0 shl 16),
	151 or (216 shl 8) or (0 shl 16),
	136 or (210 shl 8) or (0 shl 16),
	122 or (204 shl 8) or (0 shl 16),
	108 or (197 shl 8) or (0 shl 16),
	95 or (191 shl 8) or (0 shl 16),
	83 or (185 shl 8) or (0 shl 16),
	71 or (178 shl 8) or (0 shl 16),
	60 or (172 shl 8) or (0 shl 16),
	49 or (166 shl 8) or (0 shl 16),
	39 or (159 shl 8) or (0 shl 16),
	30 or (153 shl 8) or (0 shl 16),
	22 or (147 shl 8) or (0 shl 16),
	14 or (140 shl 8) or (0 shl 16),
	6 or (134 shl 8) or (0 shl 16),
	0 or (128 shl 8) or (0 shl 16));


procedure SetDepthColors(CD: TColorDepth; var DepthArray: TDepthArray);


implementation


procedure SetDepthColors(CD: TColorDepth; var DepthArray: TDepthArray);
{Set default colors }
var I: integer;
begin
case CD of
 dc12:
	begin
	SetLength(DepthArray,Length(DepthColors13));
	for I:=0 to High(DepthColors13) do DepthArray[I]:=DepthColors13[I];
	end;
 dc20:
	begin
	SetLength(DepthArray,Length(GeoColors20));
	for I:=0 to High(GeoColors20) do DepthArray[I]:=GeoColors20[I];
	end;
 dc24:
	begin
	SetLength(DepthArray,Length(DepthColors24));
	for I:=0 to High(DepthColors24) do DepthArray[I]:=DepthColors24[I];
	end;
 dc30:
	begin
	SetLength(DepthArray,Length(GeoColors30));
	for I:=0 to High(GeoColors30) do DepthArray[I]:=GeoColors30[I];
	end;
 dcTemp32:
	begin
	SetLength(DepthArray,Length(ColorTemp32));
	for I:=0 to High(ColorTemp32) do DepthArray[I]:=ColorTemp32[I];
	end;
 end;
end;


{------------------------------------------------------------------------------}


function GetHSVGradient(C1,C2: TColor; Percent: double): TColor;
var CV1,CV2: THSBRecord;
var HD: THSBRecord;
begin
CV1:=RGBToHSB(ColorToTriple(C1));
CV2:=RGBToHSB(ColorToTriple(C2));
HD.Hue:=(CV2.Hue - CV1.Hue)*Percent;
HD.Sat:=(CV2.Sat - CV1.Sat)*Percent;
HD.Bright:=(CV2.Bright - CV1.Bright)*Percent;
CV1.Hue:=CV1.Hue+HD.Hue;
CV1.Sat:=CV1.Sat+HD.Sat;
CV1.Bright:=CV1.Bright+HD.Bright;
Result:=TripleToColor(HSBtoRGB(CV1));
end;


function GetRGBGradient(C1,C2: TColor; Percent: double): TColor;
{Create color gradient between the colors in C1 and C2}
var CV1,CV2,IV: T3DVector;
begin
CV1:=ColorToVector(C1);
CV2:=ColorToVector(C2);
IV:=ScalarProduct3D(VectorSubtract3D(CV2,CV1),Percent);
Result:=VectorToColor(VectorAdd3D(CV1,IV));
end;



function GetGradientColor(A: array of TGradientItem; Percent: double): TColor;
var I: integer;
var P3: double;
begin
for I:=0 to High(A) do
 if (Percent>=A[I].Percent1) and (Percent<=A[I].Percent2) then
	begin
	P3:=(Percent-A[I].Percent1)/(A[I].Percent2-A[I].Percent1);
	case A[I].GradType of
	 gtRGB: Result:=GetRGBGradient(A[I].C1,A[I].C2,P3);
	 gtHSV: Result:=GetHSVGradient(A[I].C1,A[I].C2,P3);
	end;
	exit;
	end;
Result:=A[0].C1;
end;




end.
