unit Filmstp;

interface

uses WinTypes,Classes,Graphics,SysUtils;


{Used to access protected method - protected methods
{ are only accessible inside the same module}

type TXBitmap = class(TBitmap)
 end;


Type TOutFilm = class(TObject)
 FStream: TFileStream;
 Count: integer;
 public
 destructor Destroy; override;
 procedure OpenFile(Name: string);
 procedure CloseFile;
 procedure WriteBitmap(Bitmap: TBitmap);
 end;


Type TInFilm = class(TObject)
 FStream: TFileStream;
 Count: integer;
 public
 destructor Destroy; override;
 procedure OpenFile(Name: string);
 procedure CloseFile;
 procedure RandomRead(Bitmap: TBitmap;Inx: integer);
 function ReadBitmap(Bitmap: TBitmap): boolean;
 procedure Rewind;
 end;

implementation

{--------------------- Film output object -------------------------------------}

procedure TOutFilm.OpenFile(Name: string);
begin
FStream:=TFileStream.Create(Name,$FFFF);
Count:=0;
end;


procedure TOutFilm.CloseFile;
begin
if FStream=nil then exit;
FStream.Position:=0;
FStream.WriteBuffer(Count,Sizeof(Count));
FStream.Free;
FStream:=nil;
end;


procedure TOutFilm.WriteBitmap(Bitmap: TBitmap);
begin
if Count=0 then FStream.WriteBuffer(Count,Sizeof(Count));
TXBitmap(Bitmap).WriteData(FStream);
Inc(Count);
end;


destructor TOutFilm.Destroy;
begin
CloseFile;
inherited Destroy;
end;


{--------------------- Film input object -------------------------------------}

procedure TInFilm.OpenFile(Name: string);
begin
FStream:=TFileStream.Create(Name,0);
FStream.Read(Count,Sizeof(Count));
FStream.Position:=Sizeof(Count);
end;


procedure TInFilm.CloseFile;
begin
if FStream<>nil then FStream.Free;
FStream:=nil;
end;


procedure TInFilm.RandomRead(Bitmap: TBitmap;Inx: integer);
var P,Size: longint;
var I: integer;
begin
if Inx>=Count then exit;
P:=Sizeof(Count);
for I:=0 to Inx-1 do
	begin
	FStream.Position:=P;
	FStream.Read(Size,Sizeof(Size));
	P:=P+Size+Sizeof(Size);
	end;
FStream.Position:=P;
TXBitmap(Bitmap).ReadData(FStream);
end;


function TInFilm.ReadBitmap(Bitmap: TBitmap): boolean;
begin
Result:=False;
if FStream.Position>=FStream.Size then exit;
TXBitmap(Bitmap).ReadData(FStream);
Result:=True;
end;


procedure TInFilm.Rewind;
begin
FStream.Position:=Sizeof(Count);
end;

destructor TInFilm.Destroy;
begin
CloseFile;
inherited Destroy;
end;

end.
