unit TBMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, subtimer,BitmapLib, SpinButtons, intspin,MMSystem;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Panel1: TPanel;
    Button1: TButton;
    CardSpin: TIntegerSpin;
    Label1: TLabel;
    BackSpin: TIntegerSpin;
    Label2: TLabel;
    BackChk: TCheckBox;
    MethodGroup: TRadioGroup;
    Panel2: TPanel;
    SubTimer1: TSubTimer;
    Panel3: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
{$R CARDS}


{ Base locations in the bitmap resource file "Cards" }

const BackBase = 200;			{Base location of card back }
const CardMask = 400;			{Base location of card mask }
const CardPocket = 401;			{Base location of card pocket }
const CardHighlight = 402;		{Base location of card Highligh }
const CardShadow = 403;			{Base location of card Shadow }
const SmallOffset = 1000;		{Offset to start of small cards}


var  Face,Back,Mask: TBitmap;
var  Highlight,Shadow: TBitmap;
var  BackGround: TBitmap;
var  CardPos: TPoint;
var FaceUp: boolean;
var CardBase,BackOff: integer;

{------------------------------------------------------------------------------}

procedure AndOrMethod(Canvas: TCanvas);
begin
{Use mask to cut out corners of card}
Canvas.CopyMode:=cmSrcAnd;
Canvas.Draw(CardPos.X,CardPos.Y,Mask);
{Insures the card face will be white}
Canvas.Brush.Color:=clWhite;
{Logical OR the face into black mask area}
Canvas.CopyMode:=cmSrcPaint;
if FaceUp then Canvas.Draw(CardPos.X,CardPos.Y,Face)
else Canvas.Draw(CardPos.X,CardPos.Y,Back);

end;

{------------------------------------------------------------------------------}

procedure MaskBltMethod(Canvas: TCanvas);
const  ROP_DstCopy = $00AA0029;


	procedure MaskedDraw(BM: TBitmap);
	begin
	MaskBlt(Canvas.Handle,CardPos.X,CardPos.Y,BM.Width,BM.Height,
		BM.Canvas.Handle,0,0, Mask.Handle,0,0,
		MakeRop4(ROP_DstCopy, SrcCopy));
	end;


begin
if FaceUp then MaskedDraw(Face)
else MaskedDraw(Back);
end;


{------------------------------------------------------------------------------}

procedure DelphiMethod(Canvas: TCanvas);
begin
Face.TransparentMode:=tmFixed;
Face.TransparentColor:=clTeal;
Face.Transparent:=True;
if FaceUp then Canvas.Draw(CardPos.X,CardPos.Y,Face)
else Canvas.Draw(CardPos.X,CardPos.Y,Back);
end;


{------------------------------------------------------------------------------}


procedure LorenMethod(Dest,Source: TBitmap);
var X,Y: integer;
var SS,DS: PRGBTripleArray;
begin
for Y:=0 to Source.Height-1 do
	begin
	SS:=Source.ScanLine[Y];
	DS:=Dest.ScanLine[Y+CardPos.Y];
	for X:=0 to Source.Width-1 do
	 if (SS[X].rgbtRed<>0) or (SS[X].rgbtGreen<>128) or (SS[X].rgbtBlue<>128) then
		begin
		DS[X+CardPos.X]:=SS[X];
		end;
	end;
end;



procedure DoLorenMethod(Dest: TBitmap);
begin
if FaceUp then LorenMethod(Dest,Face)
else LorenMethod(Dest,Back);
Form1.Image1.Invalidate;
end;


{------------------------------------------------------------------------------}

procedure TransparentBltMethod(Canvas: TCanvas);
const  ROP_DstCopy = $00AA0029;


	procedure MaskedDraw(BM: TBitmap);
	begin
	TransparentBlt(Canvas.Handle,CardPos.X,CardPos.Y,BM.Width,BM.Height,
		BM.Canvas.Handle,0,0,BM.Width,BM.Height,
		RGB(0,128,128));
	end;


begin
if FaceUp then MaskedDraw(Face)
else MaskedDraw(Back);
end;



{------------------------------------------------------------------------------}

procedure BitBltMethod(Canvas: TCanvas);
const  ROP_DstCopy = $00AA0029;


	procedure MaskedDraw(BM: TBitmap);
	begin
	BitBlt(Canvas.Handle,CardPos.X,CardPos.Y,Mask.Width,Mask.Height, Mask.Canvas.Handle,0,0, SRCAND);
	BitBlt(Canvas.Handle,CardPos.X,CardPos.Y,BM.Width,BM.Height, BM.Canvas.Handle,0,0, SRCPAINT);
	end;


begin
if FaceUp then MaskedDraw(Face)
else MaskedDraw(Back);
end;



{-----------------------------------------------------------------------------}



procedure LoadCardBitmap(BM: TBitmap; Card: integer);
{Load specified card into Bitmap Windows resource}
var Tmp: TBitmap;
begin
Tmp:=TBitmap.Create;
Tmp.Handle:=LoadBitmap(HInstance,PChar(Card));
BM.Assign(Tmp);
Tmp.Free;
end;



procedure SetPixelFormat(PF: TPixelFormat);
begin
Face.PixelFormat:=PF;
Back.PixelFormat:=PF;
Form1.Image1.Picture.Bitmap.PixelFormat:=PF;
end;




procedure TForm1.FormCreate(Sender: TObject);
begin
Face:=TBitmap.Create;
Back:=TBitmap.Create;
BackGround:=TBitmap.Create;
Mask:=TBitmap.Create;
Highlight:=TBitmap.Create;
Shadow:=TBitmap.Create;

CardBase:=0;
BackOff:=CardBase + BackBase;
LoadCardBitmap(Mask,CardBase+CardMask);
LoadCardBitmap(Highlight,CardBase+CardHighlight);
LoadCardBitmap(Shadow,CardBase+CardShadow);
end;




procedure TForm1.FormDestroy(Sender: TObject);
begin
Face.Free;
Back.Free;
BackGround.Free;
Mask.Free;
Highlight.Free;
Shadow.Free;
end;



procedure TForm1.Button1Click(Sender: TObject);
begin
FaceUp:=not BackChk.Checked;
CardPos.X:=20;
CardPos.Y:=20;

LoadCardBitmap(Face,CardBase+1+CardSpin.Value);
LoadCardBitmap(Back,BackOff+BackSpin.Value);
ClearImage(Form1.Image1,clGreen);

if MethodGroup.ItemIndex=3 then SetPixelFormat(pf24Bit)
else SetPixelFormat(pfDevice);

Form1.SubTimer1.Reset;
Form1.SubTimer1.Start;
case MethodGroup.ItemIndex of
 0: AndOrMethod(Form1.Image1.Canvas);
 1: DelphiMethod(Form1.Image1.Canvas);
 2: MaskBltMethod(Form1.Image1.Canvas);
 3: DoLorenMethod(Form1.Image1.Picture.Bitmap);
 4: TransparentBltMethod(Form1.Image1.Canvas);
 5: BitBltMethod(Form1.Image1.Canvas);
 end;
Form1.SubTimer1.Stop;
Form1.SubTimer1.Display;
end;



end.
