unit IPSetup;

interface

uses Windows,Messages, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, WinSock, intspin, ScktComp, ComCtrls, Grids, IniFiles,
  Registry,MMSystem, Dialogs, NetLib, SpinButtons, CheckedGroup, CommPort, DSupport,
  ThreadLib;


type
  TIPDialog = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Panel2: TPanel;
    GroupBox3: TGroupBox;
    Panel3: TPanel;
    ShowInfoBtn: TBitBtn;
    AbortBtn: TBitBtn;
    Label4: TLabel;
    Panel4: TPanel;
    NetworkGrid: TStringGrid;
    Panel5: TPanel;
    ProgressBar: TProgressBar;
    Panel9: TPanel;
    Panel6: TPanel;
    HostEdit: TEditEx;
    Panel7: TPanel;
    IPEdit: TEditEx;
    Panel8: TPanel;
    PortSpin: TIntegerSpin;
    Label3: TLabel;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ShowInfoBtnClick(Sender: TObject);
    procedure AbortBtnClick(Sender: TObject);
    procedure NetworkGridDblClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure TransmitHandler(Sender: TObject);
    function Execute(var Host,IPAddress: string; var Port: integer): boolean;
  end;


var IPDialog: TIPDialog;



implementation


{$R *.DFM}


{--------------------- Event Handlers -----------------------------------------}


procedure TIPDialog.FormCreate(Sender: TObject);
begin
NetworkGrid.Cells[0,0]:='#';
NetworkGrid.Cells[0,0]:='Network';
NetworkGrid.Cells[1,0]:='Work Group';
NetworkGrid.Cells[2,0]:='Host';
NetworkGrid.Cells[3,0]:='IP Address';
end;



function TIPDialog.Execute(var Host,IPAddress: string; var Port: integer): boolean;
var Row: integer;
begin
HostEdit.Text:=Host;
IPEdit.Text:=IPAddress;
PortSpin.Value:=Port;
IPDialog.ShowModal;
Result:=IPDialog.ModalResult=mrOk;
if Result then
	begin
	Host:=HostEdit.Text;
	IPAddress:=IPEdit.Text;
	Port:=PortSpin.Value;
	end;
end;




{------------------------------------------------------------------------------}


procedure HandleProgress(Progress: integer);
begin
IPDialog.ProgressBar.Position:=Progress;
end;


{Put network recursion in its own thread because it can take a long time to
finish and while it is finishing, it does not allow refreshing of the screen}


type TNetThread = class(TThread)
 private
 protected
 public
  procedure Execute; override;
  function WaitForTimeout(TimeOut: integer): boolean;
 end;

var NetData: TNetworkArray;

procedure TNetThread.Execute;
begin
RecurseNetwork(NetData,nil);
end;



function TNetThread.WaitForTimeout(TimeOut: integer): boolean;
var R: cardinal;
begin
R:=WaitForSingleObject(Handle,TimeOut);
Result:=WAIT_TIMEOUT<>R;
end;



{------------------------------------------------------------------------------}

var Recurser: TNetThread;

procedure GetNetworkInfo;
var I,Row: integer;
var NetName,WrkName,CompName: string;
begin
with IPDialog do
 begin
 for I:=1 to NetworkGrid.RowCount-1 do NetworkGrid.Rows[I].Clear;
 try
 Recurser:=TNetThread.Create(False);
 while not Recurser.WaitForTimeout(100) do
	begin
	Application.ProcessMessages;
	HandleProgress((IPDialog.ProgressBar.Position+1) mod 100);
	end;
 HandleProgress(0);
 NetworkGrid.Cells[0,1]:='No Data Available';
 Row:=1;
 Screen.Cursor:=crHourGlass;
 try
 for I:=0 to NetData.Index-1 do
	begin
	case NetData.Info[I].DisType of
	 1: WrkName:=NetData.Info[I].Name;
	 2: CompName:=NetData.Info[I].Name;
	 6: NetName:=NetData.Info[I].Name;
	 end;
	if NetData.Info[I].DisType = 2 then
		begin
		NetworkGrid.Cells[0,Row]:=NetName;
		NetworkGrid.Cells[1,Row]:=WrkName;
		NetworkGrid.Cells[2,Row]:=CompName;
		NetworkGrid.Cells[3,Row]:=NetData.Info[I].IPAddress;
		Inc(Row);
		end;

	end;
 finally Screen.Cursor:=crDefault; end;
 finally FreeAndNil(Recurser); end;
 end;
end;




procedure TIPDialog.ShowInfoBtnClick(Sender: TObject);
begin
GetNetworkInfo;
end;



procedure TIPDialog.AbortBtnClick(Sender: TObject);
begin
if Recurser<>nil then TerminateThread(Recurser.Handle,0);
end;



procedure TIPDialog.TransmitHandler(Sender: TObject);
var S: string;
begin
end;




procedure TIPDialog.NetworkGridDblClick(Sender: TObject);
var Row: integer;
begin
Row:=NetworkGrid.Row;
if NetworkGrid.Cells[3,Row]<>'' then IPEdit.Text:=NetworkGrid.Cells[3,Row];
if NetworkGrid.Cells[2,Row]<>'' then HostEdit.Text:=NetworkGrid.Cells[2,Row];
end;


end.


