unit ImageEditor;

interface

uses Windows, Messages, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ComCtrls, Math, BitmapLib, SelectBox, SpinButtons, Vector, intspin,
  ImageUndoer, Dialogs, Realspin,Clipbrd, Menus,ImageEx,DottedBox, Spin,
  Gauges, CheckedGroup,IntVector,DSupport, Autobttn,VCLLibrary, Grids;

type
  TImageEditorDlg = class(TForm)
    Panel1: TPanel;
    OKBtn: TButton;
    CancelBtn: TButton;
    Panel3: TPanel;
    ScrollBox: TScrollBox;
    Image: TImageEx;
    Splitter1: TSplitter;
    SelectionBox: TSelectionBox;
    ImageUndoer: TImageUndoer;
    Panel2: TPanel;
    UndoBtn: TSpeedButton;
    ColorDialog1: TColorDialog;
    PasteBumpBtn: TSpeedButton;
    CopyBtn: TSpeedButton;
    DottedBox1: TDottedBox;
    ProgressGauge: TGauge;
    UndoDis: TPanel;
    Panel4: TPanel;
    PageControl1: TPageControl;
    ScaleSheet: TTabSheet;
    StretchBtn: TSpeedButton;
    SharpGroup: TRadioGroup;
    GroupBox2: TGroupBox;
    Label6: TLabel;
    IncUnitsDis: TLabel;
    IncRadio: TRadioGroup;
    ResetSizeBtn: TButton;
    ImageSizeDis: TPanel;
    Panel5: TPanel;
    Splitter2: TSplitter;
    PenBtn: TSpeedButton;
    FillBtn: TSpeedButton;
    ClipBoxBtn: TSpeedButton;
    PenSheet: TTabSheet;
    GroupBox1: TGroupBox;
    Label13: TLabel;
    Label14: TLabel;
    LeftColorDis: TPanel;
    RightColorDis: TPanel;
    FillSheet: TTabSheet;
    ColorFillBtn: TSpeedButton;
    ClipSheet: TTabSheet;
    ScaleBtn: TSpeedButton;
    ColorFillSheet: TTabSheet;
    ClipBtn: TSpeedButton;
    Label3: TLabel;
    Label4: TLabel;
    PixelSpin: TIntegerSpin;
    Label11: TLabel;
    MainMenu1: TMainMenu;
    Edit1: TMenuItem;
    Paste1: TMenuItem;
    Copy1: TMenuItem;
    N3: TMenuItem;
    Repeatcommand1: TMenuItem;
    Undo1: TMenuItem;
    Tools1: TMenuItem;
    GausianBlur1: TMenuItem;
    ImageEnhancement1: TMenuItem;
    FlipRotate1: TMenuItem;
    Label8: TLabel;
    ColorThresholdBar: TTrackBar;
    ColorThresholdDis: TPanel;
    RedoBtn: TSpeedButton;
    Label5: TLabel;
    FillThresholdBar: TTrackBar;
    FillThresholdDis: TPanel;
    RotateBtn: TSpeedButton;
    LeftColorBtn: TAutoButton;
    RightColorBtn: TAutoButton;
    RotationSheet: TTabSheet;
    Label9: TLabel;
    Group1: TGroupBox;
    Label10: TLabel;
    AngleSpin: TRealSpin;
    Button1: TButton;
    MeasureNorthChk: TCheckBox;
    SetSize1: TMenuItem;
    ResetBoxBtn: TSpeedButton;
    Panel6: TPanel;
    Label12: TLabel;
    EditScaleBar: TTrackBar;
    BitBtn1: TBitBtn;
    ResetZoomBtn: TAutoButton;
    CopyBoxBtn: TSpeedButton;
    PasteBoxBtn: TSpeedButton;
    RubberChk: TCheckBox;
    ScaleToolBtn: TButton;
    BlurBtn: TSpeedButton;
    BlurSheet: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    RadiusSpin: TRealSpin;
    Label15: TLabel;
    BlurSizeSpin: TIntegerSpin;
    EyeDropperBtn: TSpeedButton;
    EyeDropperSheet: TTabSheet;
    Label16: TLabel;
    CloneBtn: TSpeedButton;
    CloneSheet: TTabSheet;
    Label17: TLabel;
    Label18: TLabel;
    DottedBox2: TDottedBox;
    Panel7: TPanel;
    Panel8: TPanel;
    MouseDis: TPanel;
    Panel9: TPanel;
    ColorDis: TPanel;
    Panel10: TPanel;
    PenSizeSpin: TIntegerSpin;
    Panel11: TPanel;
    CloneStartDis: TEditEx;
    Panel12: TPanel;
    Panel13: TPanel;
    CloneDestDis: TEditEx;
    CloneSourceDis: TEditEx;
    Panel14: TPanel;
    CloneBaseDis: TEditEx;
    DodgeBtn: TSpeedButton;
    DodgeSheet: TTabSheet;
    Label7: TLabel;
    SmudgeBtn: TSpeedButton;
    SmudgeSheet: TTabSheet;
    Label22: TLabel;
    Label23: TLabel;
    SmudgeDepthSpin: TRealSpin;
    BurnExposeSpin: TRealSpin;
    Label19: TLabel;
    DodgeModeRadio: TRadioGroup;
    DodgeTypeRadio: TRadioGroup;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure EditScaleBarChange(Sender: TObject);
    procedure ImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure ImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DrawModeRadioClick(Sender: TObject);
    procedure UndoBtnClick(Sender: TObject);
    procedure ClipBtnClick(Sender: TObject);
    procedure LeftColorBtnClick(Sender: TObject);
    procedure RightColorBtnClick(Sender: TObject);
    procedure PasteBumpBtnClick(Sender: TObject);
    procedure CopyBtnClick(Sender: TObject);
    procedure ImageMouseLeave(Sender: TObject);
    procedure ResetSizeBtnClick(Sender: TObject);
    procedure StretchBtnClick(Sender: TObject);
    procedure ImageUndoerChange(Sender: TObject);
    procedure PenBtnClick(Sender: TObject);
    procedure PixelSpinChange(Sender: TObject);
    procedure GausianBlur1Click(Sender: TObject);
    procedure ImageEnhancement1Click(Sender: TObject);
    procedure IncRadioClick(Sender: TObject);
    procedure FlipRotate1Click(Sender: TObject);
    procedure ColorThresholdBarChange(Sender: TObject);
    procedure RedoBtnClick(Sender: TObject);
    procedure FillThresholdBarChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure MeasureNorthChkClick(Sender: TObject);
    procedure SetSize1Click(Sender: TObject);
    procedure ResetBoxBtnClick(Sender: TObject);
    procedure ResetZoomBtnClick(Sender: TObject);
    procedure CopyBoxBtnClick(Sender: TObject);
    procedure PasteBoxBtnClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ScaleToolBtnClick(Sender: TObject);
    procedure ScrollBoxMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure ScrollBoxMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
  private
    { Private declarations }
  public
    { Public declarations }
   procedure MouseWheelHandler(var Message: TMessage); override;
  end;

var
  ImageEditorDlg: TImageEditorDlg;

type TEdButtonState = (bsPen,bsFill,bsColorFill,bsClip,bsScale,bsRotate,bsBlur,bsClone,bsEyeDropper,bsDodge,bsSmudge);

procedure EditImage(BM: TBitmap);
function GetButtonState: TEdButtonState;


procedure ShowToolObjects(Show: boolean);

implementation

uses IEResize, IEGausian, IEEnhance, IEFlip, IERotate,
  IESetSize, IEPenDrawing, IEScaleTool, IEFill, IEClone, IEDodge;

{$R *.dfm}


var DotBox: TDottedBox;



procedure TImageEditorDlg.MouseWheelHandler(var Message: TMessage);
var hdl: THandle;
begin
hdl:= WindowFromPoint(SmallPointToPoint(TSmallPoint(Message.lParam)));
while (hdl <> 0) and (hdl <> ScrollBox.Handle) do hdl := GetParent(hdl);
if (hdl = ScrollBox.Handle) then
	begin
	Message.Result := 1;
	ScrollBox.Perform(CM_MOUSEWHEEL, Message.WParam, Message.LParam);
	end
else inherited MouseWheelHandler(Message);
end;



function GetButtonState: TEdButtonState;
begin
with ImageEditorDlg do
 begin
 if PenBtn.Down then Result:=bsPen
 else if FillBtn.Down then Result:=bsFill
 else if ColorFillBtn.Down then Result:=bsColorFill
 else if ClipBoxBtn.Down then Result:=bsClip
 else if ScaleBtn.Down then Result:=bsScale
 else if RotateBtn.Down then Result:=bsRotate
 else if BlurBtn.Down then Result:=bsBlur
 else if EyeDropperBtn.Down then Result:=bsEyeDropper
 else if CloneBtn.Down then Result:=bsClone
 else if DodgeBtn.Down then Result:=bsDodge
 else if SmudgeBtn.Down then Result:=bsSmudge;
 end;
end;


procedure TImageEditorDlg.PenBtnClick(Sender: TObject);
var BS: TEdButtonState;
begin
BS:=GetButtonState;
case BS of
 bsPen: PageControl1.ActivePage:=PenSheet;
 bsFill: PageControl1.ActivePage:=FillSheet;
 bsColorFill: PageControl1.ActivePage:=ColorFillSheet;
 bsClip: PageControl1.ActivePage:=ClipSheet;
 bsScale: PageControl1.ActivePage:=ScaleSheet;
 bsRotate: Pagecontrol1.ActivePage:=RotationSheet;
 bsBlur: PageControl1.ActivePage:=BlurSheet;
 bsEyeDropper: PageControl1.ActivePage:=EyeDropperSheet;
 bsClone: PageControl1.ActivePage:=CloneSheet;
 bsDodge: PageControl1.ActivePage:=DodgeSheet;
 bsSmudge: PageControl1.ActivePage:=SmudgeSheet;
 end;
ShowToolObjects(True);
end;


function IsClipBoxMode: boolean;
var BS: TEdButtonState;
begin
BS:=GetButtonState;
Result:=BS=bsClip;
end;


procedure ShowToolObjects(Show: boolean);
var BS: TEdButtonState;
begin
BS:=GetButtonState;
case BS of
 bsPen,bsFill,bsColorFill,bsBlur,bsClone, bsEyeDropper:
	begin
	HideOldScaleLine;
	HideOldNorthLine;
	ImageEditorDlg.SelectionBox.HideBox;
	if BS in [bsPen,bsClone] then
		begin
		if Show then
			begin
			ImageEditorDlg.DottedBox1.ShowRectangle;
			ImageEditorDlg.DottedBox2.ShowRectangle;
			end
		else
			begin
			ImageEditorDlg.DottedBox1.HideRectangle;
			ImageEditorDlg.DottedBox2.HideRectangle;
			end;
		end;
	end;
 bsClip:
	begin
	if Show then ImageEditorDlg.SelectionBox.ShowBox
	else ImageEditorDlg.SelectionBox.HideBox;
	HideOldScaleLine;
	HideOldNorthLine;
	end;
 bsScale:
	begin
	if Show and IsPaperScale then DrawScaleLine
	else HideOldScaleLine;
	ImageEditorDlg.SelectionBox.HideBox;
	HideOldNorthLine;
	end;
 bsRotate:
	begin
	if Show and ImageEditorDlg.MeasureNorthChk.Checked then DrawNorthLine
	else HideOldNorthLine;
	HideOldScaleLine;
	ImageEditorDlg.SelectionBox.HideBox;
	end;
 end;
end;




procedure DrawBlurBrush(Start: boolean; X,Y: integer);
var T: double;
begin
if Start then
	begin
	ImageEditorDlg.Image.RestoreImage;
	ImageEditorDlg.ImageUndoer.StoreUndo;
        end;

GaussBlurCircle(ImageEditorDlg.Image.Canvas,Point(X,Y),ImageEditorDlg.BlurSizeSpin.value,ImageEditorDlg.RadiusSpin.Value);
ImageEditorDlg.Image.SaveImage;
ImageEditorDlg.Image.Invalidate;
end;







{------------------------------------------------------------------------------}


var MouseBtnDown: boolean;


var PixelSampling: boolean;
var LastButton: TEdButtonState;


procedure HandleControlSample(Ctrl: boolean; BS: TEdButtonState);
begin
PixelSampling:=Ctrl and (BS in [bsPen, bsFill, bsColorFill]);
if PixelSampling then
	begin
	ImageEditorDlg.EyeDropperBtn.Down:=True;
	end;
end;


procedure FinishControlSample;
begin
if not PixelSampling then exit;
case LastButton of
 bsPen: ImageEditorDlg.PenBtn.Down:=True;
 bsFill: ImageEditorDlg.FillBtn.Down:=True;
 bsColorFill: ImageEditorDlg.ColorFillBtn.Down:=True;
 end;
PixelSampling:=False;
end;




procedure DisplayMouse(X,Y: integer);
var Scale: double;
var SX,SY: double;
var C: TColor;
var R,G,B: byte;
begin
with ImageEditorDlg do
 begin
 Scale:=EditScaleBar.Position/100;
 SX:=X / Scale; SY:=Y /Scale;
 MouseDis.Caption:=IntToStr(trunc(SX))+','+IntToStr(trunc(SY));
 C:=Image.Picture.Bitmap.Canvas.Pixels[trunc(SX),trunc(SY)];
 ColorDis.Caption:=ColorToRGBString(C);
 end;
end;


function GetDodgeMode: TDodgeBurnMode;
begin
case ImageEditorDlg.DodgeModeRadio.ItemIndex of
 0: Result:=dmHighlight;
 1: Result:=dmMidtones;
 2: Result:=dmShadows;
 end;
end;




procedure TImageEditorDlg.ImageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var BS: TEdButtonState;
var C: TColor;
var Scale: double;
var Size: integer;
var XM,YM,XS,YS: integer;
var Ctrl: boolean;
begin
Ctrl:=ssCtrl in Shift;
BS:=GetButtonState;
MouseBtnDown:=False;
if ssLeft in Shift then C:=LeftColorDis.Color
else if ssRight in Shift then C:=RightColorDis.Color
else exit;
MouseBtnDown:=True;
HandleControlSample(Ctrl,BS);
Size:=Self.PenSizeSpin.Value;
Scale:=EditScaleBar.Position/100;
XS:=Trunc(X/Scale); YS:=Trunc(Y/Scale);
GetModuloPixel(X,Y,XM,YM,Size,Scale);
case BS of
 bsPen: if Ctrl then SamplePixel(XS,YS, Shift) else DrawOnImage(True,XM,YM,Size,Scale,C);
 bsFill: if Ctrl then SamplePixel(XS,YS, Shift) else FloodFillOnImage(True,XS,YS,Size,C);
 bsColorFill: if Ctrl then SamplePixel(XS,YS, Shift) else ColorFillOnImage(True,XS,YS,Size,ColorThresholdBar.Position/100,C);
 bsClip: SelectionBox.BoxMouseDown(XM,YM);
 bsScale: if IsPaperScale then SetNewScaleStart(XM,YM);
 bsRotate: if MouseBtnDown and MeasureNorthChk.Checked then SetNorthStart(XM,YM);
 bsBlur: DrawBlurBrush(True, XS,YS);
 bsEyeDropper: SamplePixel(XS,YS, Shift);
 bsClone: CloneMouseDown(XM,YM,Shift);
 bsDodge: DoDodge(True, XS,YS,Size,DodgeTypeRadio.ItemIndex=0, GetDodgeMode,BurnExposeSpin.Value);
 bsSmudge: DoSmudge(True,XM,YM,Size,SmudgeDepthSpin.Value);
 end;
LastButton:=BS;
end;



procedure TImageEditorDlg.ImageMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
var Flood: boolean;
var BS: TEdButtonState;
var C: TColor;
var Scale: double;
var Size: integer;
var XM,YM,XS,YS: integer;
begin
DisplayMouse(X,Y);
if ssLeft in Shift then C:=LeftColorDis.Color
else if ssRight in Shift then C:=RightColorDis.Color;
Scale:=EditScaleBar.Position/100;
Size:=PenSizeSpin.Value;
XS:=round(X/Scale); YS:=round(Y/Scale);

GetModuloPixel(X,Y,XM,YM,Size,Scale);

BS:=GetButtonState;
case BS of
 bsPen: if MouseBtnDown then DrawOnImage(False,XM,YM,Size,Scale,C)
	else DrawPenBox1(Image,X,Y,Size,Scale,True);
 bsFill: if MouseBtnDown then FloodFillOnImage(False,XS,YS,Size,C);
 bsColorFill: if MouseBtnDown then ColorFillOnImage(False,XS,YS,Size,ColorThresholdBar.Position/100,C);
 bsClip: SelectionBox.BoxMouseMove(XM,YM);
 bsScale: if MouseBtnDown and IsPaperScale then SetNewScaleEnd(XM,YM);
 bsRotate: if MouseBtnDown and MeasureNorthChk.Checked then SetNorthEnd(XM,YM);
 bsBlur: if MouseBtnDown then DrawBlurBrush(False, XS,YS);
 bsEyeDropper: SamplePixel(XS,YS, Shift);
 bsClone: CloneMouseMove(X,Y,XM,YM,Scale,Shift);
 bsDodge: if MouseBtnDown then DoDodge(False, XS,YS,Size,DodgeTypeRadio.ItemIndex=0,GetDodgeMode,BurnExposeSpin.Value)
	   else DrawPenBox1(Image,X,Y,Size,Scale,True);
 bsSmudge: if MouseBtnDown then DoSmudge(False,XM,YM,Size,SmudgeDepthSpin.Value)
	   else DrawPenBox1(Image,X,Y,Size,Scale,True);
 end;
end;



procedure TImageEditorDlg.ImageMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
FinishControlSample;
MouseBtnDown:=False;
SelectionBox.BoxMouseUp;
end;



procedure TImageEditorDlg.EditScaleBarChange(Sender: TObject);
var Scale: double;
begin
Scale:=EditScaleBar.Position/100;
ZoomImageScrollBox(ScrollBox,Image,Scale);
end;



procedure TImageEditorDlg.DrawModeRadioClick(Sender: TObject);
begin
if IsClipBoxMode then SelectionBox.ShowBox
else SelectionBox.HideBox;
ClipBtn.Enabled:=IsClipBoxMode;
end;



procedure TImageEditorDlg.UndoBtnClick(Sender: TObject);
var OldSize: T2DVector;
var SX,SY: integer;
begin
ShowToolObjects(False);
try
SX:=ScrollBox.HorzScrollBar.Position;
SY:=ScrollBox.VertScrollBar.Position;
OldSize:=MakeVector2D(Image.Width,Image.Height);
ImageUndoer.Undo;
NormalizeImageSize(Image);
Image.SaveImage;
GetInputSize;                             
RescaleScaleLine(OldSize,MakeVector2D(NewSizeX,NewSizeY));
EditScaleBarChange(Sender);
ScrollBox.HorzScrollBar.Position:=SX;
ScrollBox.VertScrollBar.Position:=SY;
finally ShowToolObjects(True); end;
Image.Repaint;
end;



procedure TImageEditorDlg.RedoBtnClick(Sender: TObject);
var SX,SY: integer;
begin
ShowToolObjects(False);
try
SX:=ScrollBox.HorzScrollBar.Position;
SY:=ScrollBox.VertScrollBar.Position;
ImageUndoer.Redo;
NormalizeImageSize(Image);
Image.SaveImage;
GetInputSize;
EditScaleBarChange(Sender);
ScrollBox.HorzScrollBar.Position:=SX;
ScrollBox.VertScrollBar.Position:=SY;
finally ShowToolObjects(True); end;
Image.Repaint;
end;



{-------------------Do Image Clipping -----------------------------------------}


procedure TImageEditorDlg.ClipBtnClick(Sender: TObject);
var R: TRect;
begin
R:=SelectionBox.SelectionBox;
ShowToolObjects(False);
ImageUndoer.StoreUndo;
ClipBitmap(Image.Picture.Bitmap,SelectionBox.SelectionBox);
NormalizeImageSize(Image);
Image.SaveImage;
SelectionBox.SelectionBox:=Rect(0,0,10,10);
ShowToolObjects(True);
end;




procedure GetPenColor(Panel: TPanel);
begin
ImageEditorDlg.ColorDialog1.Color:=Panel.Color;
if ImageEditorDlg.ColorDialog1.Execute then
	Panel.Color:=ImageEditorDlg.ColorDialog1.Color;
end;



procedure TImageEditorDlg.LeftColorBtnClick(Sender: TObject);
begin
GetPenColor(LeftColorDis);
end;



procedure TImageEditorDlg.RightColorBtnClick(Sender: TObject);
begin
GetPenColor(RightColorDis);
end;



procedure TImageEditorDlg.PasteBumpBtnClick(Sender: TObject);
var R: TRect;
begin
ShowToolObjects(False);
ImageUndoer.StoreUndo;
ShowToolObjects(True);
Image.Picture.Bitmap.LoadFromClipboardFormat(cf_BitMap,ClipBoard.GetAsHandle(cf_Bitmap),0);
NormalizeImageSize(Image);
Image.SaveImage;
end;




procedure TImageEditorDlg.PasteBoxBtnClick(Sender: TObject);
var BM: TBitmap;
var R: TRect;
begin
BM:=TBitmap.Create;
try
ShowToolObjects(False);
ImageUndoer.StoreUndo;
ShowToolObjects(True);

SelectionBox.HideBox;
try
BM.LoadFromClipboardFormat(cf_BitMap,ClipBoard.GetAsHandle(cf_Bitmap),0);
Image.Picture.Bitmap.Canvas.Draw(SelectionBox.SelectionBox.Left,SelectionBox.SelectionBox.Top,BM);
R:=SelectionBox.SelectionBox;
R.Right:=R.Left+BM.Width;
R.Bottom:=R.Top+BM.Height;
SelectionBox.SetAndShowBox(R);
finally SelectionBox.ShowBox end;

NormalizeImageSize(Image);
Image.SaveImage;
finally BM.Free; end;
end;





procedure TImageEditorDlg.CopyBtnClick(Sender: TObject);
var MyFormat: Word;
var AData: THandle;
var APalette: HPALETTE;
begin
Image.Picture.Bitmap.SaveToClipBoardFormat(MyFormat,AData,APalette);
ClipBoard.SetAsHandle(MyFormat,AData);
end;



procedure TImageEditorDlg.CopyBoxBtnClick(Sender: TObject);
var MyFormat: Word;
var AData: THandle;
var APalette: HPALETTE;
var BM: TBitmap;
var R: TRect;
begin
BM:=TBitmap.Create;
try
SelectionBox.HideBox;
try
BM.Width:=SelectionBox.SelectionBox.Right-SelectionBox.SelectionBox.Left;
BM.Height:=SelectionBox.SelectionBox.Bottom-SelectionBox.SelectionBox.Top;
BM.Canvas.CopyRect(Rect(0,0,BM.Width,BM.Height),Image.Canvas,SelectionBox.SelectionBox);
finally SelectionBox.ShowBox; end;
BM.SaveToClipBoardFormat(MyFormat,AData,APalette);
ClipBoard.SetAsHandle(MyFormat,AData);
finally BM.Free; end;
end;



procedure TImageEditorDlg.ImageMouseLeave(Sender: TObject);
begin
DottedBox1.HideRectangle;
end;



procedure TImageEditorDlg.ResetSizeBtnClick(Sender: TObject);
begin
GetInputSize;
NormalizeSize(True);
end;




procedure TImageEditorDlg.StretchBtnClick(Sender: TObject);
begin
ShowToolObjects(False);
try
ResizeImage;
NormalizeImageSize(Image);
GetInputSize;
finally ShowToolObjects(True); end;
end;



procedure TImageEditorDlg.ImageUndoerChange(Sender: TObject);
begin
UndoDis.Caption:=IntToStr(ImageUndoer.Count);
end;


procedure TImageEditorDlg.PixelSpinChange(Sender: TObject);
begin
NormalizeSize(True);
end;

procedure TImageEditorDlg.GausianBlur1Click(Sender: TObject);
begin
DoGausianDlg;
end;

procedure TImageEditorDlg.ImageEnhancement1Click(Sender: TObject);
begin
ShowToolObjects(False);
ImageUndoer.StoreUndo;
DoEnhanceDlg;
Image.SaveImage;
ShowToolObjects(True);
end;




procedure TImageEditorDlg.IncRadioClick(Sender: TObject);
begin
PixelSpin.Increment:=StrToIntDef(IncRadio.Items[IncRadio.ItemIndex],1);
end;



procedure TImageEditorDlg.FlipRotate1Click(Sender: TObject);
begin
DoFlipDlg;
end;



procedure TImageEditorDlg.FormCreate(Sender: TObject);
begin
ScrollBox.DoubleBuffered:=True;
SelectionBox.SelectionBox:=Rect(0,0,50,50);
SelectionBox.HideBox;
PenBtnClick(Sender);
end;


procedure EditImage(BM: TBitmap);
begin
ResetScaleLine;
ResetNorthLine;
ImageEditorDlg.ImageUndoer.Clear;
ResetBrightContrastGamma(False);
ImageEditorDlg.EditScaleBar.Position:=100;
BM.PixelFormat:=pf24Bit;
ImageEditorDlg.Image.AutoSize:=True;
ImageEditorDlg.Image.Picture.Assign(BM);

ImageEditorDlg.Image.AutoSize:=False;
ImageEditorDlg.Image.SaveImage;
GetInputSize;
NormalizeSize(True);
ImageEditorDlg.ShowModal;
if ImageEditorDlg.ModalResult=mrOK then
	begin
	ShowToolObjects(False);
	BM.Assign(ImageEditorDlg.Image.Picture.Bitmap);
	ShowToolObjects(True);
	end;
end;



procedure TImageEditorDlg.ColorThresholdBarChange(Sender: TObject);
begin
ColorThresholdDis.Caption:=FloatToStrF(ColorThresholdBar.Position/100,ffFixed,18,2);
end;



procedure TImageEditorDlg.MeasureNorthChkClick(Sender: TObject);
begin
if MeasureNorthChk.Checked then DrawNorthLine
else HideOldNorthLine;
end;



procedure TImageEditorDlg.FillThresholdBarChange(Sender: TObject);
var T: double;
begin
T:=FillThresholdBar.Position/100;
T:=GammaFunction(T);
FillThresholdDis.Caption:=FloatToStrF(T,ffFixed,18,2);
end;



procedure TImageEditorDlg.Button1Click(Sender: TObject);
begin
DoCurrentRotation;
end;




procedure TImageEditorDlg.SetSize1Click(Sender: TObject);
begin
ShowToolObjects(False);
ImageUndoer.StoreUndo;
DoImageResize(Image);
Image.SaveImage;
ShowToolObjects(True);
end;






procedure TImageEditorDlg.ResetBoxBtnClick(Sender: TObject);
begin
SelectionBox.SelectionBox:=Rect(0,0,50,50);
ScrollBox.HorzScrollBar.Position:=0;
ScrollBox.VertScrollBar.Position:=0;
end;

procedure TImageEditorDlg.ResetZoomBtnClick(Sender: TObject);
begin
ImageEditorDlg.EditScaleBar.Position:=100;
end;


procedure TImageEditorDlg.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
ImageUndoer.Clear;
if ScaleToolDlg.Visible then ScaleToolDlg.Close;
end;



procedure TImageEditorDlg.ScaleToolBtnClick(Sender: TObject);
begin
ShowScaleTool;
end;



procedure TImageEditorDlg.ScrollBoxMouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
ScrollBox.VertScrollBar.Position:=ScrollBox.VertScrollBar.Position+20;
end;


procedure TImageEditorDlg.ScrollBoxMouseWheelUp(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin
ScrollBox.VertScrollBar.Position:=ScrollBox.VertScrollBar.Position-20;
end;




end.
