unit IEFlip;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls,BitmapLib;

type
  TFlipDlg = class(TForm)
    CancelBtn: TButton;
    FliptHorizBtn: TButton;
    FlipVerticalBtn: TButton;
    Flip90Btn: TButton;
    Flip180Btn: TButton;
    Flip270Btn: TButton;
    BitBtn1: TBitBtn;
    procedure Flip90BtnClick(Sender: TObject);
    procedure Flip180BtnClick(Sender: TObject);
    procedure Flip270BtnClick(Sender: TObject);
    procedure FlipVerticalBtnClick(Sender: TObject);
    procedure FliptHorizBtnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FlipDlg: TFlipDlg;

procedure DoFlipDlg;

implementation

uses ImageEditor;

{$R *.dfm}





procedure TFlipDlg.Flip90BtnClick(Sender: TObject);
var BM: TBitmap;
begin
BM:=TBitmap.Create;
try
FlipBitmap90(ImageEditorDlg.Image.Picture.Bitmap,BM);
ImageEditorDlg.Image.Picture.Bitmap.Assign(BM);
ImageEditorDlg.Image.SaveImage;
NormalizeImageSize(ImageEditorDlg.Image);
ImageEditorDlg.Image.Invalidate;
finally BM.Free; end;
end;




procedure TFlipDlg.Flip180BtnClick(Sender: TObject);
var BM: TBitmap;
begin
BM:=TBitmap.Create;
try
FlipBitmap180(ImageEditorDlg.Image.Picture.Bitmap,BM);
ImageEditorDlg.Image.Picture.Bitmap.Assign(BM);
ImageEditorDlg.Image.SaveImage;
ImageEditorDlg.Image.Invalidate;
finally BM.Free; end;
end;


procedure TFlipDlg.Flip270BtnClick(Sender: TObject);
var BM: TBitmap;
begin
BM:=TBitmap.Create;
try
FlipBitmap270(ImageEditorDlg.Image.Picture.Bitmap,BM);
ImageEditorDlg.Image.Picture.Bitmap.Assign(BM);
ImageEditorDlg.Image.SaveImage;
NormalizeImageSize(ImageEditorDlg.Image);
ImageEditorDlg.Image.Invalidate;
finally BM.Free; end;
end;


procedure TFlipDlg.FlipVerticalBtnClick(Sender: TObject);
var BM: TBitmap;
begin
BM:=TBitmap.Create;
try
FlipBitmapVertical(ImageEditorDlg.Image.Picture.Bitmap,BM);
ImageEditorDlg.Image.Picture.Bitmap.Assign(BM);
ImageEditorDlg.Image.SaveImage;
ImageEditorDlg.Image.Invalidate;
finally BM.Free; end;
end;


procedure TFlipDlg.FliptHorizBtnClick(Sender: TObject);
var BM: TBitmap;
begin
BM:=TBitmap.Create;
try
FlipBitmapHoriz(ImageEditorDlg.Image.Picture.Bitmap,BM);
ImageEditorDlg.Image.Picture.Bitmap.Assign(BM);
ImageEditorDlg.Image.SaveImage;
ImageEditorDlg.Image.Invalidate;
finally BM.Free; end;
end;




procedure DoFlipDlg;
begin
ShowToolObjects(False);
ImageEditorDlg.ImageUndoer.StoreUndo;
FlipDlg.ShowModal;
ImageEditorDlg.Image.SaveImage;
ShowToolObjects(True);
end;



end.
