unit IEPreciseSize;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, intspin, SpinButtons;

type
  TPreciseSizeDlg = class(TForm)
    OKBtn: TButton;
    CancelBtn: TButton;
    Bevel1: TBevel;
    Label1: TLabel;
    Label2: TLabel;
    WidthSpin: TIntegerSpin;
    HeightSpin: TIntegerSpin;
    AspectChk: TCheckBox;
    procedure WidthSpinChange(Sender: TObject);
    procedure HeightSpinChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  PreciseSizeDlg: TPreciseSizeDlg;

procedure DoSizingDlg;

implementation

{$R *.DFM}

uses ImageEditor, IEResize;


var WidthChange: boolean=False;
var HeightChange: boolean=False;

procedure DoSizingDlg;
begin
WidthChange:=True;
HeightChange:=True;
PreciseSizeDlg.WidthSpin.Value:=NewSizeX;
PreciseSizeDlg.HeightSpin.Value:=NewSizeY;
WidthChange:=False;
HeightChange:=False;

PreciseSizeDlg.ShowModal;
if PreciseSizeDlg.ModalResult=mrOK then
	begin
	NewSizeX:=PreciseSizeDlg.WidthSpin.Value;
	NewSizeY:=PreciseSizeDlg.HeightSpin.Value;
	DisplaySize;
	end;
end;

procedure TPreciseSizeDlg.WidthSpinChange(Sender: TObject);
begin
if not AspectChk.Checked or WidthChange then exit;
WidthChange:=True;
HeightSpin.Value:=trunc(WidthSpin.Value/AspectRatio);
WidthChange:=False;
end;

procedure TPreciseSizeDlg.HeightSpinChange(Sender: TObject);
begin
if not AspectChk.Checked or HeightChange then exit;
HeightChange:=True;
WidthSpin.Value:=trunc(HeightSpin.Value*AspectRatio);
HeightChange:=False;
end;


end.
