unit IEResize;

interface

uses Windows,Graphics,SysUtils,Types,Resizebm,Dialogs,Vector,IntVector,Math,
     DSupport;

procedure GetInputSize;
procedure NormalizeSize(DisplayScale: boolean);
procedure ResizeImage;
procedure DisplaySize;



var NewSizeX,NewSizeY: integer;
var BaseSizeX,BaseSizeY: integer;
var AspectRatio: double;
var SizeScale: double;



implementation

uses ImageEditor;



{------------------Routine to resize image ---------------------------}

procedure ResizeProgress(V: integer);
begin
ImageEditorDlg.ProgressGauge.Progress:=V;
end;



function GetSharpness: integer;
{Get sharpness Index from control}
begin
case ImageEditorDlg.SharpGroup.ItemIndex of
 0: Result:=4;
 1: Result:=5;
 2: Result:=6;
 end;
end;



procedure ResizeImage;
{Resize InputImage and put in Output Image}
begin
with ImageEditorDlg do
 begin
 if (NewSizeX<0) or (NewSizeY<0) then
	begin
	MessageDlg('Negative Image Size',mtWarning,[mbOk],0);
	exit;
	end;        
 Image.RestoreImage;
 ImageUndoer.StoreUndo;
 Image.AutoSize:=True;
 StretchBitmap(Image.Picture.Bitmap,NewSizeX,NewSizeY, GetSharpness, ResizeProgress);
 Image.SaveImage;
 end;
end;



procedure GetInputSize;
{Get basic input image size}
begin
BaseSizeX:=ImageEditorDlg.Image.Picture.Width;
BaseSizeY:=ImageEditorDlg.Image.Picture.Height;
NewSizeX:=BaseSizeX;
NewSizeY:=BaseSizeY;
ImageEditorDlg.PixelSpin.Value:=0;
if NewSizeY = 0 then AspectRatio:=1
else AspectRatio:=NewSizeX/NewSizeY;
end;




procedure DisplaySize;
{Display what size will be after resizing}
begin
with ImageEditorDlg do
 begin
 ImageSizeDis.Caption:=' '+IntToStr(NewSizeX)+' x '+IntToStr(NewSizeY);
 end;
end;



procedure NormalizeSize(DisplayScale: boolean);
{Normalize aspect ratio and display new size}
begin
with ImageEditorDlg do
 begin
 NewSizeX:=BaseSizeX + PixelSpin.Value;
 NewSizeY:=round(NewSizeX / AspectRatio);
 SizeScale:=NewSizeX/BaseSizeX;
 DisplaySize;
 end;
end;



end.
