unit IERotate;

interface

uses Windows,Graphics,Types,ExtCtrls,Math,IntVector,DSupport,GraphicsLib,BitmapLib;

procedure ResetNorthLine;
procedure DrawNorthLine;
procedure HideOldNorthLine;
procedure SetNorthStart(X,Y: integer);
procedure SetNorthEnd(X,Y: integer);

procedure DoCurrentRotation;


implementation

uses ImageEditor, IEResize;

var NorthStart,NorthEnd: TPoint;


{-------------- Routines Handle Scaling ---------------------------------------}


procedure ResetNorthLine;
begin
NorthStart:=Point(0,0);
NorthEnd:=Point(0,0);
end;


procedure DisplayNorthSize;
var D: TPoint;
begin
D:=IntVectorSubtract(NorthEnd,NorthStart);
ImageEditorDlg.AngleSpin.Value:=(ArcTan2(D.Y,D.X)* Radian2Degree)+90;
end;



procedure DrawNorthLine;
var L: double;
begin
with ImageEditorDlg do
 begin
 Image.Canvas.Pen.Color:=clRed;
 Image.Canvas.Pen.Width:=1;
 DrawArrowLine(Image.Canvas,NorthStart,NorthEnd,False,True,10,4);
 DisplayNorthSize;
 end;
end;


procedure HideOldNorthLine;
var R: TRect;
begin
R.TopLeft:=NorthStart;
R.BottomRight:=NorthEnd;
R:=NormalizeRect(R);
InflateRect(R,10,10);
ImageEditorDlg.Image.RestoreRectangle(R);
end;


procedure SetNorthStart(X,Y: integer);
begin
HideOldNorthLine;
NorthStart:=Point(X,Y);
NorthEnd:=Point(X,Y);
end;


procedure SetNorthEnd(X,Y: integer);
begin
HideOldNorthLine;
NorthEnd:=Point(X,Y);
DrawNorthLine;
end;



procedure DoCurrentRotation;
var BM: TBitmap;
var Angle: double;
var P: TPoint;
begin
BM:=TBitmap.Create;
try
ShowToolObjects(False);
Angle:=360-ImageEditorDlg.AngleSpin.Value;
P:=Point(ImageEditorDlg.Image.Width div 2,ImageEditorDlg.Image.Height div 2);
ImageEditorDlg.ImageUndoer.StoreUndo;
RotateBitmap(ImageEditorDlg.Image.Picture.Bitmap,BM,foFit,P,Angle,1,clWhite);
ImageEditorDlg.Image.Picture.Bitmap.Assign(BM);
NormalizeImageSize(TImage(ImageEditorDlg.Image));
ImageEditorDlg.Image.SaveImage;
GetInputSize;

RotatePoint(NorthEnd,NorthStart,ImageEditorDlg.AngleSpin.Value);
ShowToolObjects(True);
finally BM.Free; end;
end;



end.
