unit GetImageSizeDlg;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls, 
  Buttons, ExtCtrls, SpinButtons, intspin;

type
  TImageSizeDlg = class(TForm)
    Panel1: TPanel;
    OKBtn: TButton;
    CancelBtn: TButton;
    Panel2: TPanel;
    WidthSpin: TIntegerSpin;
    HeightSpin: TIntegerSpin;
    Label1: TLabel;
    Label2: TLabel;
    AspectChk: TCheckBox;
    procedure WidthSpinChange(Sender: TObject);
    procedure HeightSpinChange(Sender: TObject);
    procedure AspectChkClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ImageSizeDlg: TImageSizeDlg;

function GetImageSize(var AWidth,AHeight: integer): boolean;

implementation

{$R *.dfm}

var AspectRatio: double;

function GetImageSize(var AWidth,AHeight: integer): boolean;
begin
with ImageSizeDlg do
 begin
 Result:=False;
 WidthSpin.NoEventValue:=AWidth;
 HeightSpin.NoEventValue:=AHeight;
 AspectRatio:=AWidth/AHeight;
 ImageSizeDlg.ShowModal;
 if ImageSizeDlg.ModalResult=mrOK then
	begin
	AWidth:=WidthSpin.Value;
	AHeight:=HeightSpin.Value;
	Result:=True;
	end;
 end;
end;



procedure TImageSizeDlg.WidthSpinChange(Sender: TObject);
begin
if AspectChk.Checked then HeightSpin.NoEventValue:=Round(WidthSpin.Value / AspectRatio);
end;



procedure TImageSizeDlg.HeightSpinChange(Sender: TObject);
begin
if AspectChk.Checked then WidthSpin.NoEventValue:=Round(HeightSpin.Value * AspectRatio);
end;



procedure TImageSizeDlg.AspectChkClick(Sender: TObject);
begin
WidthSpinChange(Sender);
end;


end.
