unit MSHTMLLib;

interface

uses Forms,Windows,Messages,Graphics,Types,Classes,Controls,ExtCtrls,SysUtils,ResizeBM,ShDocVw,ActiveX,MSHTML,Variants,IntVector;

procedure GetAllLinks(Dispatch: IDispatch;  SL: TStringList);
procedure GetAllLinksExt(Dispatch: IDispatch; SL: TStringList);
procedure GetAllFormNames(Dispatch: IDispatch; SL: TStringList);
function GetFormByName(Dispatch: IDispatch; const formName: string): IHTMLFormElement;
function GetInnerHTML(WB: TWebBrowser): string;
function GetInnerText(WB: TWebBrowser): string;
function GetOuterHTML(WB: TWebBrowser): string;
function GetBrowserHTML(const webBrowser: TWebBrowser): String;
procedure SetInnerHTML(WB: TWebBrowser; const HTMLString: string);


procedure GetAllStyleSheetStrs(Dispatch: IDispatch;  SL: TStringList);
procedure GetAllStyleSheets(Dispatch: IDispatch; var List: TList);
procedure InsertStylesheetStr(WB: TWebBrowser; const Style,Title: string); overload;
procedure InsertStylesheetStr(WB: TWebBrowser; const Style: string); overload;
procedure SetStyleSheetByTitle(WB: TWebBrowser;  const Title,Style: string);
procedure DeleteStyleSheet(Dispatch: IDispatch; I: integer);


procedure SetFieldValue(theForm: IHTMLFormElement; const fieldName: string; const newValue: string);
procedure GetFormFieldNames(fromForm: IHTMLFormElement; SL: TStringList; AddDescription: boolean);
function GetElementByName(Dispatch: IDispatch; const Name: string): IHTMLElement;
function SubmitByElementName(Dispatch: IDispatch; const Name: string): boolean;
procedure LoadDocFromString(WB: TWebBrowser; const HTMLString: string);
procedure LoadDocFromStream(WB: TWebBrowser; Stream: TStream);
procedure ScrollBrowser(WB: TWebBrowser; X,Y: integer);
function GetBrowserImageSize(Browser: TWebBrowser): TPoint;

function GetBrowserImage(Browser: TWebBrowser; ShowScrollbars: boolean): TBitmap; overload;
function GetBrowserImage(Browser: TWebBrowser; ShowScrollbars: boolean; OutputSize: TPoint; BottomTrim: integer; Quality: TImageQuality): TBitmap;  overload;

implementation





procedure LoadDocFromStream(WB: TWebBrowser; Stream: TStream);
var PersistStreamInit: IPersistStreamInit;
var StreamIntf: IStream;
var StreamAdapter: TStreamAdapter;
begin
PersistStreamInit:= WB as IPersistStreamInit;
StreamAdapter:=TStreamAdapter.Create(Stream);
StreamIntf:=StreamAdapter as IStream;
PersistStreamInit.Load(StreamIntf);
end;




procedure LoadDocFromString(WB: TWebBrowser; const HTMLString: string);
var V: OleVariant;
var  HTMLDocument: IHTMLDocument2;
begin
HTMLDocument := WB.Document as IHTMLDocument2;
if HTMLDocument=nil then
	begin
	WB.Navigate('about:blank');
        HTMLDocument := WB.Document as IHTMLDocument2;
	end;

V:= VarArrayCreate([0, 0], varVariant);
V[0]:=HTMLString;
HTMLDocument.Write(PSafeArray(TVarData(v).VArray));
HTMLDocument.Close;
end;




function GetBrowserHTML(const webBrowser: TWebBrowser): String;
var strStream: TStringStream;
var adapter: IStream;
var browserStream: IPersistStreamInit;
begin
strStream := TStringStream.Create('');
try
browserStream := webBrowser.Document as IPersistStreamInit;
adapter := TStreamAdapter.Create(strStream,soReference);
browserStream.Save(adapter,true);
result := strStream.DataString;
finally strStream.Free(); end;
end;





procedure SetInnerHTML(WB: TWebBrowser; const HTMLString: string);
var  HTMLDocument: IHTMLDocument2;
begin
HTMLDocument := WB.Document as IHTMLDocument2;
HTMLDocument.Body.innerHTML:=HTMLString;
end;



function GetOuterHTML(WB: TWebBrowser): string;
begin
Result:=WB.OleObject.Document.documentElement.OuterHTML;
end;



function GetInnerHTML(WB: TWebBrowser): string;
begin
Result:=WB.OleObject.Document.documentElement.innerHTML;
end;



function GetInnerText(WB: TWebBrowser): string;
{Returns text that would be visible in the browser}
begin
Result:=WB.OleObject.Document.documentElement.innerText;
end;



procedure GetAllLinksExt(Dispatch: IDispatch;  SL: TStringList);
var AllLinks: IHTMLElementCollection;
var Link: IHTMLElement;
var I: integer;
var Document: IHTMLDocument2;
begin
Document:=Dispatch as IHTMLDocument2;
AllLinks:= Document.Links;
SL.Clear;
for I:=0 to AllLinks.length-1 do
	begin
	Link:=AllLinks.Item(I,'') as IHTMLElement;
	SL.Add('InnerText: '+Link.innerText+' Class Name: '+Link.className+'| LinkID: '+Link.id+'| Tag Name: '+Link.tagName+'| Title: '+Link.title+'| Link: '+Link.toString);
	end;
end;



procedure GetAllLinks(Dispatch: IDispatch;  SL: TStringList);
var AllLinks: IHTMLElementCollection;
var Link: IHTMLElement;
var I: integer;
var Document: IHTMLDocument2;
begin
Document:=Dispatch as IHTMLDocument2;
AllLinks:= Document.Links;
SL.Clear;
for I:=0 to AllLinks.length-1 do
	begin
	Link:=AllLinks.Item(I,'') as IHTMLElement;
	SL.Add(Link.toString);
	end;
end;


{------------------- Style Sheet routines -------------------------------------}



procedure DeleteStyleSheet(Dispatch: IDispatch; I: integer);
var StyleSheets: IHTMLStyleSheetsCollection;
var Sheet: IHTMLStyleSheet;
var Dis: IDispatch;
var Inx: OleVariant;
var Document: IHTMLDocument2;
begin
Document:=Dispatch as IHTMLDocument2;
StyleSheets:= Document.StyleSheets;
if (I<0) or (I>StyleSheets.length-1) then exit;
Inx:=I;
Dis:=StyleSheets.Item(Inx);
if Dis.QueryInterface(IID_IHTMLStyleSheet,Sheet)=0 then
	begin
	Sheet.cssText:=' ';
	Sheet.disabled:=True;
	end;
end;



procedure GetAllStyleSheetStrs(Dispatch: IDispatch; SL: TStringList);
var StyleSheets: IHTMLStyleSheetsCollection;
var Sheet: IHTMLStyleSheet;
var Dis: IDispatch;
var I: integer;
var Inx: OleVariant;
var Document: IHTMLDocument2;
begin
Document:=Dispatch as IHTMLDocument2;
StyleSheets:= Document.StyleSheets;
SL.Clear;

for I:=0 to StyleSheets.length-1 do
	begin
	Inx:=I;
	Dis:=StyleSheets.Item(Inx);
	if Dis.QueryInterface(IID_IHTMLStyleSheet,Sheet)=0 then
		SL.Add(Sheet.title+' | '+Sheet.cssText);
	end;
end;


procedure GetAllStyleSheets(Dispatch: IDispatch; var List: TList);
var StyleSheets: IHTMLStyleSheetsCollection;
var Sheet: IHTMLStyleSheet;
var Dis: IDispatch;
var I: integer;
var Inx: OleVariant;
var Document: IHTMLDocument2;
begin
Document:=Dispatch as IHTMLDocument2;
StyleSheets:= Document.StyleSheets;
List.Clear;

for I:=0 to StyleSheets.length-1 do
	begin
	Inx:=I;
	Dis:=StyleSheets.Item(Inx);
	if Dis.QueryInterface(IID_IHTMLStyleSheet,Sheet)=0 then
		begin
		Sheet._AddRef;
		List.Add(Pointer(Sheet));
		end;
	end;
end;



function GetStyleSheetByTitle(Dispatch: IDispatch; const Title: string): IHTMLStyleSheet;
var StyleSheets: IHTMLStyleSheetsCollection;
var Dis: IDispatch;
var I: integer;
var Inx: OleVariant;
var Document: IHTMLDocument2;
begin
Document:=Dispatch as IHTMLDocument2;
if Document=nil then exit;
StyleSheets:= Document.StyleSheets;
for I:=0 to StyleSheets.length-1 do
	begin
	Inx:=I;
	Dis:=StyleSheets.Item(Inx);
	if Dis.QueryInterface(IID_IHTMLStyleSheet,Result)=0 then
	 if Result.title=Title then exit;
	end;
Result:=nil;
end;



procedure InsertStylesheetStr(WB: TWebBrowser; const Style,Title: string);
var HTMLDocument: IHTMLDocument2;
var styleSheet: IHTMLStyleSheet;
begin
HTMLDocument:=WB.Document as IHTMLDocument2;
if HTMLDocument=nil then exit;
StyleSheet:=HTMLDocument.createStyleSheet('',-1);
StyleSheet.cssText:=Style;
StyleSheet.disabled:=False;
StyleSheet.title:=Title;
HTMLDocument.Close;
end;



procedure InsertStylesheetStr(WB: TWebBrowser; const Style: string);
begin
InsertStylesheetStr(WB,Style,'');
end;



procedure SetStyleSheetByTitle(WB: TWebBrowser;  const Title,Style: string);
var StyleSheet: IHTMLStyleSheet;
begin
StyleSheet:=GetStyleSheetByTitle(WB.Document,Title);
if StyleSheet<>nil then
	begin
	StyleSheet.cssText:=Style;
	StyleSheet.disabled:=False;
	end
else InsertStylesheetStr(WB,Style,Title);
end;



{------------------------------------------------------------------------------}


procedure GetAllFormNames(Dispatch: IDispatch; SL: TStringList);
var AllForms: IHTMLElementCollection;
var Form: IHTMLFormElement;
var I: integer;
var Document: IHTMLDocument2;
begin
Document:=Dispatch as IHTMLDocument2;
AllForms:=Document.Forms;
SL.Clear;
for I:=0 to AllForms.length-1 do
	begin
	Form:=AllForms.Item(I,'') as IHTMLFormElement;
	SL.Add(Form.name);
	end;
end;



function GetFormByName(Dispatch: IDispatch; const formName: string): IHTMLFormElement;
var forms: IHTMLElementCollection;
var Document: IHTMLDocument2;
begin
Document:=Dispatch as IHTMLDocument2;
forms:= document.Forms as IHTMLElementCollection;
result:= forms.Item(formName,'') as IHTMLFormElement;
end;




procedure GetFormFieldNames(fromForm: IHTMLFormElement; SL: TStringList; AddDescription: boolean);
var index: integer;
var field: IHTMLElement;
var input: IHTMLInputElement;
var select: IHTMLSelectElement;
var text: IHTMLTextAreaElement;
var S: string;
begin
SL.Clear;
if fromForm=nil then exit;
for index := 0 to fromForm.length do
	begin
	field := fromForm.Item(index,'') as IHTMLElement;
	if Assigned(field) then
		begin
		if field.tagName = 'INPUT' then
			begin
			// Input field.
			input := field as IHTMLInputElement;
			if AddDescription then S:='Input: ' else S:='';
			SL.Add(S+input.name);
			end
		else if field.tagName = 'SELECT' then
			begin
			// Select field.
			select := field as IHTMLSelectElement;
			if AddDescription then S:='Select: ' else S:='';
			SL.Add(S+select.name);
			end
		else if field.tagName = 'TEXTAREA' then
			begin
			// TextArea field.
			text := field as IHTMLTextAreaElement;
			if AddDescription then S:='Text Area: ' else S:='';
			SL.Add(S+text.name);
			end;
		end;
	end;
end;



procedure SetFieldValue(theForm: IHTMLFormElement; const fieldName: string; const newValue: string);
var field: IHTMLElement;
var inputField: IHTMLInputElement;
var selectField: IHTMLSelectElement;
var textField: IHTMLTextAreaElement;
begin
if theForm=nil then exit;
field := theForm.Item(fieldName,'') as IHTMLElement;
if Assigned(field) then
	begin
	if field.tagName = 'INPUT' then
		begin
		inputField := field as IHTMLInputElement;
		inputField.value := newValue;
		end
	else if field.tagName = 'SELECT' then
		begin
		selectField := field as IHTMLSelectElement;
		selectField.value := newValue;
		end
	else if field.tagName = 'TEXTAREA' then
		begin
		textField := field as IHTMLTextAreaElement;
		textField.value := newValue;
		end;
	end;
end;




function GetElementByName(Dispatch: IDispatch; const Name: string): IHTMLElement;
var AllElements: IHTMLElementCollection;
var Document: IHTMLDocument2;
begin
Document:=Dispatch as IHTMLDocument2;
AllElements:= document.All as IHTMLElementCollection;
result:= AllElements.Item(Name,'') as IHTMLElement;
end;



function SubmitByElementName(Dispatch: IDispatch; const Name: string): boolean;
var Element: IHTMLElement;
begin
Element:=GetElementByName(Dispatch,Name);
Result:=Element<>nil;
if Result then Element.click;
end;


procedure ScrollBrowser(WB: TWebBrowser; X,Y: integer);
var document: IHTMLDocument2;
begin
document := WB.Document as IHTMLDocument2;
if Assigned(document) then document.parentWindow.scrollBy(X,Y);
end;



{----------- Routines to Hanle Saving Browser Size-State ----------------------}


var OldAlign: TAlign;
var OldOverflowX,OldOverflowY: OleVariant;
var XScroll,YScroll,OldWidth,OldHeight: integer;

procedure SaveBrowserState(Browser: TWebBrowser);
{Save browser size and scroll-state}
begin
OldOverflowX:=Browser.OleObject.Document.Body.Style.OverflowX;
OldOverflowY:=Browser.OleObject.Document.Body.Style.OverflowY;
XScroll:=Browser.OleObject.Document.Body.scrollLeft;
YScroll:=Browser.OleObject.Document.Body.scrollTop;
OldWidth:=Browser.Width;
OldHeight:=Browser.Height;
OldAlign:=Browser.Align;
end;


procedure RestoreBrowserState(Browser: TWebBrowser);
{Restore browser size and scroll-state}
{Restoration order is important}
begin
Browser.OleObject.Document.Body.Style.OverflowX:=OldOverflowX;
Browser.OleObject.Document.Body.Style.OverflowY:=OldOverflowY;
Browser.OleObject.Document.Body.scrollLeft:=XScroll;
Browser.OleObject.Document.Body.scrollTop:=YScroll;
{These items must be last}
Browser.Width:=OldWidth;
Browser.Height:=OldHeight;
Browser.Align:=OldAlign;
end;

{------------------------------------------------------------------------------}


procedure BlockWindowUpdate(Owner: TWinControl; Block: boolean);
begin
SendMessage(Owner.Handle, WM_SETREDRAW, Ord(not Block), 0);
{I don't think this really does anything}
if not Block then Owner.Invalidate;
end;



function GetBrowserImageSize(Browser: TWebBrowser): TPoint;
var Document: IHTMLDocument2;
var Element: IHTMLElement2;
begin
if not Assigned(Browser.Document) then exit;
if Browser.Document.QueryInterface(IHTMLDocument2, Document) <> S_OK then exit;
if not Assigned(Document.Body) then exit;
if Document.Body.QueryInterface(IHTMLElement2, Element) <> S_OK then exit;
Browser.Visible:=False;
{Lock the window so all the changes we are making will be invisible}
BlockWindowUpdate(Browser,True);
try
SaveBrowserState(Browser);
try

{turn off alignment so we can change the browser window size}
Browser.Align:=alNone;
{Force the browser to be small so the minimum size need to render page is returned}
Browser.Width:=100;
Browser.Height:=100;

Result.X:=Element.scrollWidth;
Result.Y:=Element.scrollHeight;
finally RestoreBrowserState(Browser); end;
finally BlockWindowUpdate(Browser,False); end;
end;





function GetBrowserImage(Browser: TWebBrowser; ShowScrollbars: boolean): TBitmap;
{Load full-sized image of the web page in the specified browser}
var ViewObject: IViewObject;
var DrawRect: TRect;
var X,Y: integer;
begin
Result:=TBitmap.Create;
if Browser.Document=nil then exit;
Browser.Document.QueryInterface(IViewObject, ViewObject);
if ViewObject=nil then exit;
try
SaveBrowserState(Browser);
{Lock the window so all the changes we are making will be invisible}
BlockWindowUpdate(Browser,True);
try
{Get the web image size plus a little to compensate for the scroll bars}
X:=Browser.OleObject.document.body.scrollWidth;
Y:=Browser.OleObject.document.body.scrollHeight;
if ShowScrollbars then
	begin
	{Compensate for scrollbar size by making the image bigger}
	{ However if we make them too big they will auto hide}
	X:=X + 8;
	Y:=Y + 8;
	end
else
	begin
	Browser.OleObject.Document.Body.Style.OverflowX:='hidden';
	Browser.OleObject.Document.Body.Style.OverflowY:='hidden';
	end;
try
{Force the browser to be the full size of the web page}
{turn off alignment to allow this to happen }
Browser.Align:=alNone;
Browser.Width:=X;
Browser.Height:=Y;
{Size the bitmap to match the browser size}
Result.Width:=X;
Result.Height:=Y;
{Draw the browser image on the bitmap}
DrawRect:=Rect(0, 0, Result.Width, Result.Height);
ViewObject.Draw(DVASPECT_CONTENT, 1, nil, nil, Application.Handle, Result.Canvas.Handle, @DrawRect, nil, nil, 0);
finally RestoreBrowserState(Browser); end;
finally BlockWindowUpdate(Browser,False); end;
finally ViewObject._Release; end;
end;




function GetBrowserImage(Browser: TWebBrowser; ShowScrollbars: boolean; OutputSize: TPoint; BottomTrim: integer; Quality: TImageQuality): TBitmap;
begin
Result:=GetBrowserImage(Browser,ShowScrollbars);
StretchBitmap(Result, OutputSize.X,OutputSize.Y,Quality,Nil);
if BottomTrim>0 then Result.Height:=Result.Height-BottomTrim;
end;


end.
