unit PaperSizes;

interface

uses Classes,Types,Vector;

procedure FillStringsPaperSize(Strings: TStrings);

type TPaperSize = record
 Name: string;
 SizeInfo: string;
 Size: T2DVector;
 end;

const PaperSizeList: array [0..67] of TPaperSize = (
	(Name: 'US Letter'; SizeInfo:'8 1/2- by 11-in.'; Size:(X:8.500; Y:11.000)),
	(Name: 'US Legal'; SizeInfo:'8 1/2- by 14-in.'; Size:(X:8.500; Y:14.000)),
	(Name: 'US Executive'; SizeInfo:'7 1/4- by 10 1/2-in.'; Size:(X:7.250; Y:10.500)),
	(Name: 'US Std Fanfold'; SizeInfo:'11- by 14 7/8-in.'; Size:(X:14.875; Y:11.000)),
	(Name: 'US #10 Envelope'; SizeInfo:'4.125- by 9.5-in.'; Size:(X:4.125; Y:9.500)),
	(Name: 'Statement'; SizeInfo:'5 1/2- by 8 1/2-in.'; Size:(X:5.500; Y:8.500)),
	(Name: 'Arch A'; SizeInfo:'9- by 12-in.'; Size:(X:9.000; Y:12.000)),
	(Name: 'Arch B'; SizeInfo:'12- by 18-in.'; Size:(X:12.000; Y:18.000)),
	(Name: 'Arch C'; SizeInfo:'18- by 24-in.'; Size:(X:18.000; Y:24.000)),
	(Name: 'Arch D'; SizeInfo:'24- by 36-in.'; Size:(X:24.000; Y:36.000)),
	(Name: 'Arch E'; SizeInfo:'36- by 48-in.'; Size:(X:36.000; Y:48.000)),
	(Name: 'Arch E1'; SizeInfo:'30- by 42-in.'; Size:(X:30.000; Y:42.000)),
	(Name: 'C Sheet'; SizeInfo:'17- by 22-in.'; Size:(X:17.000; Y:22.000)),
	(Name: 'D Sheet'; SizeInfo:'22- by 34-in.'; Size:(X:22.000; Y:34.000)),
	(Name: 'E Sheet'; SizeInfo:'34- by 44-in.'; Size:(X:34.000; Y:44.000)),
	(Name: '10- by 14-in. sheet '; SizeInfo:'10- by 14-in.'; Size:(X:10.000; Y:14.000)),
	(Name: '11- by 17-in. sheet '; SizeInfo:'11- by 17-in.'; Size:(X:11.000; Y:17.000)),
	(Name: 'Folio'; SizeInfo:'8 1/2- by 13-in.'; Size:(X:8.500; Y:13.000)),
	(Name: 'German Std Fanfold'; SizeInfo:'8 1/2- by 12-in.'; Size:(X:8.500; Y:12.000)),
	(Name: 'Ledger/Tabloid'; SizeInfo:'11- by 17-in.'; Size:(X:11.000; Y:17.000)),
	(Name: 'A0'; SizeInfo:'841- by 1189-mm.'; Size:(X:33.1; Y:46.8)),
	(Name: 'A1'; SizeInfo:'594- by 841-mm.'; Size:(X:23.4; Y:33.1)),
	(Name: 'A2'; SizeInfo:'420- by 594-mm.'; Size:(X:16.5; Y:23.4)),
	(Name: 'A3 sheet'; SizeInfo:'297- by 420-mm.'; Size:(X:11.693; Y:16.535)),
	(Name: 'A4 Sheet'; SizeInfo:'210- by 297-mm.'; Size:(X:8.268; Y:11.693)),
	(Name: 'A4 small sheet'; SizeInfo:'210- by 297-mm.'; Size:(X:8.268; Y:11.693)),
	(Name: 'A5 sheet'; SizeInfo:'148- by 210-mm.'; Size:(X:5.827; Y:8.268)),
	(Name: 'A6'; SizeInfo:'105- by 148-mm.'; Size:(X:4.134; Y:5.827)),
	(Name: 'A7'; SizeInfo:'74- by 105-mm.'; Size:(X:2.913; Y:4.134)),
	(Name: 'A8'; SizeInfo:'52- by 74-mm.'; Size:(X:2.047; Y:2.913)),
	(Name: 'A9'; SizeInfo:'37- by 52-mm.'; Size:(X:1.457; Y:2.047)),
	(Name: 'A10'; SizeInfo:'26- by 37-mm.'; Size:(X:1.024; Y:1.457)),
	(Name: 'B0'; SizeInfo:'1000- by 1414-mm.'; Size:(X:39.370; Y:55.669)),
	(Name: 'B1'; SizeInfo:'707- by 1000-mm.'; Size:(X:27.835; Y:39.370)),
	(Name: 'B2'; SizeInfo:'500- by 707-mm.'; Size:(X:19.685; Y:27.835)),
	(Name: 'B3'; SizeInfo:'353- by 500-mm.'; Size:(X:13.898; Y:19.685)),
	(Name: 'B4 sheet'; SizeInfo:'250- by 354-mm.'; Size:(X:9.843; Y:13.937)),
	(Name: 'B5 sheet'; SizeInfo:'182- by 257-mm.'; Size:(X:7.165; Y:10.118)),
	(Name: 'B6'; SizeInfo:'125- by 176-mm.'; Size:(X:4.921; Y:6.929)),
	(Name: 'B7'; SizeInfo:'88- by 125-mm.'; Size:(X:3.465; Y:4.921)),
	(Name: 'B8'; SizeInfo:'62- by 88-mm.'; Size:(X:2.441; Y:3.465)),
	(Name: 'B9'; SizeInfo:'44- by 62-mm.'; Size:(X:1.732; Y:2.441)),
	(Name: 'B10'; SizeInfo:'31- by 44-mm.'; Size:(X:1.220; Y:1.732)),
	(Name: 'C0'; SizeInfo:'917- by 1297-mm.'; Size:(X:36.102; Y:51.063)),
	(Name: 'C1'; SizeInfo:'648- by 917-mm.'; Size:(X:25.512; Y:36.102)),
	(Name: 'C2'; SizeInfo:'458- by 648-mm.'; Size:(X:18.031; Y:25.512)),
	(Name: 'C3'; SizeInfo:'324- by 458-mm.'; Size:(X:12.756; Y:18.031)),
	(Name: 'C4'; SizeInfo:'229- by 324-mm.'; Size:(X:9.016; Y:12.756)),
	(Name: 'C5'; SizeInfo:'162- by 229-mm.'; Size:(X:6.378; Y:9.016)),
	(Name: 'C6'; SizeInfo:'114- by 162-mm.'; Size:(X:4.488; Y:6.378)),
	(Name: 'C7'; SizeInfo:'81- by 114-mm.'; Size:(X:3.189; Y:4.488)),
	(Name: 'C8'; SizeInfo:'57- by 81-mm.'; Size:(X:2.244; Y:3.189)),
	(Name: 'C9'; SizeInfo:'40- by 57-mm.'; Size:(X:1.575; Y:2.244)),
	(Name: 'C10'; SizeInfo:'28- by 40-mm.'; Size:(X:1.102; Y:1.575)),
	(Name: 'CSE'; SizeInfo:'462- by 649-pt.'; Size:(X:6.417; Y:9.014)),
	(Name: 'D1'; SizeInfo:'545- by 771-mm.'; Size:(X:21.457; Y:30.354)),
	(Name: 'D2'; SizeInfo:'385- by 545-mm.'; Size:(X:15.157; Y:21.457)),
	(Name: 'D3'; SizeInfo:'272- by 385-mm.'; Size:(X:10.709; Y:15.157)),
	(Name: 'D4'; SizeInfo:'192- by 272-mm.'; Size:(X:7.559; Y:10.709)),
	(Name: 'D5'; SizeInfo:'136- by 192-mm.'; Size:(X:5.354; Y:7.559)),
	(Name: 'D6'; SizeInfo:'96- by 136-mm.'; Size:(X:3.780; Y:5.354)),
	(Name: 'D7'; SizeInfo:'68- by 96-mm.'; Size:(X:2.677; Y:3.780)),
	(Name: 'DL Envelope'; SizeInfo:'110- by 220-mm.'; Size:(X:4.331; Y:8.661)),
	(Name: 'E3'; SizeInfo:'400- by 560-mm.'; Size:(X:15.748; Y:22.047)),
	(Name: 'E4'; SizeInfo:'280- by 400-mm.'; Size:(X:11.024; Y:15.748)),
	(Name: 'E5'; SizeInfo:'200- by 280-mm.'; Size:(X:7.874; Y:11.024)),
	(Name: 'E6'; SizeInfo:'140- by 200-mm.'; Size:(X:5.512; Y:7.874)),
	(Name: 'Quarto'; SizeInfo:'215- by 275-mm.'; Size:(X:8.465; Y:10.827))
	);




implementation


procedure FillStringsPaperSize(Strings: TStrings);
var I: integer;
var S: string;
var P: TPaperSize;
begin
Strings.Clear;
for I:=0 to High(PaperSizeList) do
	begin
	P:=PaperSizeList[I];
	S:=P.Name+' '+P.SizeInfo;
	Strings.Add(S);
	end;
end;




end.
