unit TimeLibrary;

interface

uses Windows,ComCtrls,SysUtils,DateUtils,DSupport;

function GMTToLocalTime(DT: TDateTime): TDateTime;
function GMTToTimeZone(DT: TDateTime; TimeZone: double): TDateTime;
function GetISOString(DT: TDateTime): string; overload;
function GetISOString(DT: TDateTime; TimeZone: double): string; overload;
function LocalTimeToGMT(DT: TDateTime): TDateTime;


function PickersToDateTime(Date,Time: TDateTimePicker): TDateTime;
function PickersToSysTime(Date,Time: TDateTimePicker): TSystemTime;

function GetFileDateStr(FileDate: TFileTime; Show24Hour,LocalTime,ShowMS: boolean): string;

implementation




function GetFileDateStr(FileDate: TFileTime; Show24Hour,LocalTime,ShowMS: boolean): string;
var ST: TSystemTime;
var MK: integer;
begin
if LocalTime then FileTimeToLocalFileTime(FileDate,FileDate);
FileTimeToSystemTime(FileDate,ST);
Result:=PadInteger(ST.wMonth,2)+'/'+PadInteger(ST.wDay,2)+'/'+IntToStr(ST.wYear)+' - ';
MK:=PickInteger(Show24Hour,24,12);
Result:=Result+PadInteger(ST.wHour mod MK,2)+':'+PadInteger(ST.wMinute,2)+':'+PadInteger(ST.wSecond,2);
if ShowMS then  Result:=Result+'.'+PadInteger(ST.wMilliseconds,3);
if not Show24Hour then Result:=Result+PickString(ST.wHour>12,' PM',' AM');
end;


function LocalTimeToGMT(DT: TDateTime): TDateTime;
var TimeZoneInfo: TTimeZoneInformation;
begin
GetTimeZoneInformation(TimeZoneInfo);
Result:=IncMinute(DT,TimeZoneInfo.Bias);
end;




function GetISOString(DT: TDateTime): string;
var AYear, AMonth, ADay, AHour, AMinute, ASecond, AMilliSecond: Word;
begin
DecodeDateTime(DT, AYear, AMonth, ADay, AHour, AMinute, ASecond, AMilliSecond);
Result:=IntToStr(AYear)+'-'+PadInteger(AMonth,2)+'-'+PadInteger(ADay,2);
Result:=Result+'T'+PadInteger(AHour,2)+':'+PadInteger(AMinute,2)+':'+PadInteger(ASecond,2);
end;


function GetTimeZoneStr(TimeZone: double): string;
var Min,Hrs: integer;
begin
Min:=Trunc(Frac(TimeZone)*60);
Hrs:=trunc(abs(TimeZone));

Result:=PadInteger(Hrs,2)+':'+PadInteger(Min,2);
if TimeZone>=0 then Result:='+'+Result
else Result:='-'+Result;
end;



function GetISOString(DT: TDateTime; TimeZone: double): string;
begin
Result:=GetISOString(DT);
Result:=Result+GetTimeZoneStr(TimeZone);
end;



function GMTToTimeZone(DT: TDateTime; TimeZone: double): TDateTime;
begin
Result:=IncMinute(DT,trunc(TimeZone * 60));
end;



function GMTToLocalTime(DT: TDateTime): TDateTime;
var TimeZoneInfo: TTimeZoneInformation;
begin
GetTimeZoneInformation(TimeZoneInfo);
Result:=IncMinute(DT,-TimeZoneInfo.Bias);
end;



function PickersToSysTime(Date,Time: TDateTimePicker): TSystemTime;
{Get Date/Time specified by the Date and time pickers and convert to system time}
begin
DecodeDate(Date.Date,Result.wYear,Result.wMonth,Result.wDay);
DecodeTime(Time.DateTime,Result.wHour,Result.wMinute,Result.wSecond,Result.wMilliseconds);
{The time picker doesn't have the ability to enter factions of second}
{This prevents it from being a random value}
Result.wMilliseconds:=0;
end;



function PickersToDateTime(Date,Time: TDateTimePicker): TDateTime;
{Get Date/Time specified by the Date and time pickers and convert to system time}
var ST: TSystemTime;
begin
ST:=PickersToSysTime(Date,Time);
Result:=SystemTimeToDateTime(ST);
end;



end.
