unit CmdLine;

interface

uses Forms,Windows, Messages, SysUtils, Classes, Controls, ExtCtrls, ScrollEditor, StdCtrls,
     SpinButtons, Autobttn;

type TCmdLine = class(TCustomPanel)
 private
    FOnKeyPress: TKeyPressEvent;
    FOnEditorChange: TNotifyEvent;
    FOnDownClick: TNotifyEvent;
    FOnUpClick: TNotifyEvent;
    FOnCmdBtnClick: TNotifyEvent;
    procedure HandleDownClick(Sender: TObject);
    procedure HandleEditorChange(Sender: TObject);
    procedure HandleCmdBtnClick(Sender: TObject);
    procedure HandleKeyPress(Sender: TObject; var Key: Char);
    procedure HandleUpClick(Sender: TObject);
 protected
 public
  CmdEditor: TScrollEditor;
  CmdSpin: TUpDownButton;
  CmdBtn: TAutoButton;
  constructor Create(AOwner: TComponent); override;
  destructor Destroy; override;
 published
  property OnKeyPress: TKeyPressEvent read FOnKeyPress write FOnKeyPress;
  property OnUpClick: TNotifyEvent read FOnUpClick write FOnUpClick;
  property OnDownClick: TNotifyEvent read FOnDownClick write FOnDownClick;
  property OnEditorChange: TNotifyEvent read FOnEditorChange write FOnEditorChange;
  property OnCmdBtnClick: TNotifyEvent read FOnCmdBtnClick write FOnCmdBtnClick;
 end;

procedure Register;

implementation



procedure Register;
begin
RegisterComponents('Fountain', [TCmdLine]);
end;

{ TCmdLine }


procedure TCmdLine.HandleKeyPress(Sender: TObject; var Key: Char);
begin
if Assigned(FOnKeyPress) then FOnKeyPress(Sender,Key);
end;


procedure TCmdLine.HandleUpClick(Sender: TObject);
begin
if Assigned(FOnUpClick) then FOnUpClick(Sender);
end;


procedure TCmdLine.HandleDownClick(Sender: TObject);
begin
if Assigned(FOnDownClick) then FOnDownClick(Sender);
end;


procedure TCmdLine.HandleEditorChange(Sender: TObject);
begin
if Assigned(FOnEditorChange) then FOnEditorChange(Sender);
end;


procedure TCmdLine.HandleCmdBtnClick(Sender: TObject);
begin
if Assigned(FOnCmdBtnClick) then FOnCmdBtnClick(Sender);
end;


constructor TCmdLine.Create(AOwner: TComponent);
begin
inherited;
Caption:='';
Height:=21;
BevelOuter:=bvLowered;
BorderStyle:=bsSingle;

CmdEditor:=TScrollEditor.Create(Self);
CmdEditor.Parent:=Self;
CmdEditor.Align:=alClient;
CmdEditor.EditorStyle:=esSingleLine;
CmdEditor.KeyMapping:=kmXEDLite;
CmdEditor.ScrollBars:=ssNone;
CmdEditor.OnKeyPress:=HandleKeyPress;
CmdEditor.OnChange:=HandleEditorChange;
CmdEditor.StandAlone:=True;

CmdSpin:=TUpDownButton.Create(Self);
CmdSpin.Parent:=Self;
CmdSpin.Align:=alLeft;
CmdSpin.Width:=15;
CmdSpin.OnUpClick:=HandleUpClick;
CmdSpin.OnDownClick:=HandleDownClick;

CmdBtn:=TAutoButton.Create(Self);
CmdBtn.Parent:=Self;
CmdBtn.Align:=alLeft;
CmdBtn.Width:=16;
CmdBtn.Left:=16;
CmdBtn.OnClick:=HandleCmdBtnClick;
end;



destructor TCmdLine.Destroy;
begin
CmdBtn.Free;
CmdSpin.Free;
CmdEditor.Free;
inherited;
end;



end.
