unit CommPort;

interface

uses Messages,Windows,Classes,Forms,SysUtils,DSupport,syncobjs,MMSystem;

const WM_SerialReceive =  WM_USER + 2878;
const WM_SerialTransmit = WM_USER + 2879;
const WM_SerialEvent =    WM_USER + 2880;

{Non standard baud rates - may not work on all computers/serial ports}
{CBR_128000, CBR_256000 are defined by Windows and also non-standard}

const CBR_230400 = $38400;
const CBR_460800 = $70800;
const CBR_500000 = $7A120;
const CBR_512000 = $7D000;
const CBR_921600 = $E1000;
const CBR_1000000 = $F4240;
const CBR_1024000 = $FA000;
const CBR_1500000 = $16E360;
const CBR_2000000 = $1E8480;
const CBR_2500000 = $2625A0;


type TSerialPort=(
                  tptCom1, tptCom2, tptCom3, tptCom4, tptCom5, tptCom6, tptCom7, tptCom8,
                  tptCom9, tptCom10, tptCom11, tptCom12, tptCom13, tptCom14, tptCom15, tptCom16,
                  tptCom17, tptCom18, tptCom19, tptCom20, tptCom21, tptCom22, tptCom23, tptCom24,
                  tptCom25, tptCom26, tptCom27, tptCom28, tptCom29, tptCom30, tptCom31, tptCom32,

                  tptCom33, tptCom34, tptCom35, tptCom36, tptCom37, tptCom38, tptCom39, tptCom40,
                  tptCom41, tptCom42, tptCom43, tptCom44, tptCom45, tptCom46, tptCom47, tptCom48,
                  tptCom49, tptCom50, tptCom51, tptCom52, tptCom53, tptCom54, tptCom55, tptCom56,
                  tptCom57, tptCom58, tptCom59, tptCom60, tptCom61, tptCom62, tptCom63, tptCom64,
                  tptCom65, tptCom66, tptCom67, tptCom68, tptCom69, tptCom70, tptCom71, tptCom72,
                  tptCom73, tptCom74, tptCom75, tptCom76, tptCom77, tptCom78, tptCom79, tptCom80,
                  tptCom81, tptCom82, tptCom83, tptCom84, tptCom85, tptCom86, tptCom87, tptCom88,
                  tptCom89, tptCom90, tptCom91, tptCom92, tptCom93, tptCom94, tptCom95, tptCom96,
                  tptCom97, tptCom98, tptCom99, tptCom100, tptCom101, tptCom102, tptCom103, tptCom104,

                  tptCom105, tptCom106, tptCom107, tptCom108, tptCom109, tptCom110, tptCom111, tptCom112,
                  tptCom113, tptCom114, tptCom115, tptCom116, tptCom117, tptCom118, tptCom119, tptCom120,
                  tptCom121, tptCom122, tptCom123, tptCom124, tptCom125, tptCom126, tptCom127, tptCom128,
                  tptCom129, tptCom130, tptCom131, tptCom132, tptCom133, tptCom134, tptCom135, tptCom136,
                  tptCom137, tptCom138, tptCom139, tptCom140, tptCom141, tptCom142, tptCom143, tptCom144,
                  tptCom145, tptCom146, tptCom147, tptCom148, tptCom149, tptCom150, tptCom151, tptCom152,
                  tptCom153, tptCom154, tptCom155, tptCom156, tptCom157, tptCom158, tptCom159, tptCom160,
                  tptCom161, tptCom162, tptCom163, tptCom164, tptCom165, tptCom166, tptCom167, tptCom168,
                  tptCom169, tptCom170, tptCom171, tptCom172, tptCom173, tptCom174, tptCom175, tptCom176,
                  tptCom177, tptCom178, tptCom179, tptCom180, tptCom181, tptCom182, tptCom183, tptCom184,
                  tptCom185, tptCom186, tptCom187, tptCom188, tptCom189, tptCom190, tptCom191, tptCom192,
                  tptCom193, tptCom194, tptCom195, tptCom196, tptCom197, tptCom198, tptCom199, tptCom200,
                  tptCom201, tptCom202, tptCom203, tptCom204, tptCom205, tptCom206, tptCom207, tptCom208,
                  tptCom209, tptCom210, tptCom211, tptCom212, tptCom213, tptCom214, tptCom215, tptCom216,
                  tptCom217, tptCom218, tptCom219, tptCom220, tptCom221, tptCom222, tptCom223, tptCom224,
                  tptCom225, tptCom226, tptCom227, tptCom228, tptCom229, tptCom230, tptCom231, tptCom232,
                  tptCom233, tptCom234, tptCom235, tptCom236, tptCom237, tptCom238, tptCom239, tptCom240,
                  tptCom241, tptCom242, tptCom243, tptCom244, tptCom245, tptCom246, tptCom247, tptCom248,
                  tptCom249, tptCom250, tptCom251, tptCom252, tptCom253, tptCom254, tptCom255, tptCom256,
                  tptNone);



{ Note: There may be problems with baud rates above 115200 }
  TBaudRate=(tbr110,tbr300,tbr600,tbr1200,tbr2400,tbr4800,tbr9600,
             tbr14400,tbr19200,tbr38400,tbr56000,tbr57600,tbr115200,
             tbr128000, tbr230400, tbr256000, tbr460800, tbr500000,
             tbr512000, tbr921600, tbr1000000, tbr1024000, tbr1500000,
             tbr2000000, tbr2500000);

  TParity=(tpNone,tpOdd,tpEven,tpMark,tpSpace);

  TDataBits=(tdbFour,tdbFive,tdbSix,tdbSeven,tdbEight);

  TStopBits=(tsbOne,tsbOnePointFive,tsbTwo);

const MaxCommPorts = integer(tptNone)+1;

const CommPortStrs: array [0..MaxCommPorts-1] of string =
	('Com1', 'Com2', 'Com3', 'Com4', 'Com5', 'Com6', 'Com7', 'Com8', 'Com9',
         'Com10', 'Com11', 'Com12', 'Com13', 'Com14', 'Com15', 'Com16', 'Com17',
         'Com18', 'Com19', 'Com20', 'Com21', 'Com22', 'Com23', 'Com24', 'Com25',
         'Com26', 'Com27', 'Com28', 'Com29', 'Com30', 'Com31', 'Com32',

         'Com33', 'Com34', 'Com35', 'Com36', 'Com37', 'Com38', 'Com39', 'Com40',
         'Com41', 'Com42', 'Com43', 'Com44', 'Com45', 'Com46', 'Com47', 'Com48',
         'Com49', 'Com50', 'Com51', 'Com52', 'Com53', 'Com54', 'Com55', 'Com56',
         'Com57', 'Com58', 'Com59', 'Com60', 'Com61', 'Com62', 'Com63', 'Com64',
         'Com65', 'Com66', 'Com67', 'Com68', 'Com69', 'Com70', 'Com71', 'Com72',
         'Com73', 'Com74', 'Com75', 'Com76', 'Com77', 'Com78', 'Com79', 'Com80',
         'Com81', 'Com82', 'Com83', 'Com84', 'Com85', 'Com86', 'Com87', 'Com88',
         'Com89', 'Com90', 'Com91', 'Com92', 'Com93', 'Com94', 'Com95', 'Com96',
         'Com97', 'Com98', 'Com99', 'Com100', 'Com101', 'Com102', 'Com103',
         'Com104', 'Com105', 'Com106', 'Com107', 'Com108', 'Com109', 'Com110',
         'Com111', 'Com112', 'Com113', 'Com114', 'Com115', 'Com116', 'Com117',
         'Com118', 'Com119', 'Com120', 'Com121', 'Com122', 'Com123', 'Com124',
         'Com125', 'Com126', 'Com127', 'Com128', 'Com129', 'Com130', 'Com131',
         'Com132', 'Com133', 'Com134', 'Com135', 'Com136', 'Com137', 'Com138',
         'Com139', 'Com140', 'Com141', 'Com142', 'Com143', 'Com144', 'Com145',
         'Com146', 'Com147', 'Com148', 'Com149', 'Com150', 'Com151', 'Com152',
         'Com153', 'Com154', 'Com155', 'Com156', 'Com157', 'Com158', 'Com159',
         'Com160', 'Com161', 'Com162', 'Com163', 'Com164', 'Com165', 'Com166',
         'Com167', 'Com168', 'Com169', 'Com170', 'Com171', 'Com172', 'Com173',
         'Com174', 'Com175', 'Com176', 'Com177', 'Com178', 'Com179', 'Com180',
         'Com181', 'Com182', 'Com183', 'Com184', 'Com185', 'Com186', 'Com187',
         'Com188', 'Com189', 'Com190', 'Com191', 'Com192', 'Com193', 'Com194',
         'Com195', 'Com196', 'Com197', 'Com198', 'Com199', 'Com200', 'Com201',
         'Com202', 'Com203', 'Com204', 'Com205', 'Com206', 'Com207', 'Com208',
         'Com209', 'Com210', 'Com211', 'Com212', 'Com213', 'Com214', 'Com215',
         'Com216', 'Com217', 'Com218', 'Com219', 'Com220', 'Com221', 'Com222',
         'Com223', 'Com224', 'Com225', 'Com226', 'Com227', 'Com228', 'Com229',
         'Com230', 'Com231', 'Com232', 'Com233', 'Com234', 'Com235', 'Com236',
         'Com237', 'Com238', 'Com239', 'Com240', 'Com241', 'Com242', 'Com243',
         'Com244', 'Com245', 'Com246', 'Com247', 'Com248', 'Com249', 'Com250',
         'Com251', 'Com252', 'Com253', 'Com254', 'Com255', 'Com256',
         'None');

const MaxBaudRates = integer(tbr2500000)+1;

const BaudRateStrs: array [0..MaxBaudRates-1] of string = (
	'110','300','600','1,200','2,400','4,800','9,600',
	'14,400','19,200','38,400','56,000','57,600','115,200',
	'128,000', '230,400', '256,000', '460,800', '500,000',
	'512,000', '921,600', '1,000,000', '1,024,000', '1,500,000',
	'2,000,000', '2,500,000');

const MaxParity = integer(tpSpace)+1;

const ParityStrs: array [0..MaxParity-1] of string = ('N','O','E','M','S');

const MaxDataBits = integer(tdbEight)+1; 

const DataBitStrs: array [0..MaxParity-1] of string = ('4','5','6','7','8');

const MaxStopBits = integer(tsbTwo)+1;

const StopBitStrs: array [0..MaxStopBits-1] of string = ('1','1.5','2');


{ =================== Information on Handshake bits ==========================

0  - ($0001) Binary data - in Windows always 1
1  - ($0002) Enables parity checking
2  - ($0004) Suspend output if CTS is false.
3  - ($0008) Suspend output if DSR is false

4  - ($0010) Enable DTR Line
5  - ($0020) Enable DTR handshaking
6  - ($0040) Ignore data if DSR not true
7  - ($0080) Continue transmitting when receive buffer full

8  - ($0100) Transmission stops/starts when XOff/XOn char received
9  - ($0200) Send XOff/XOn when receive butter is Full/Empty
10 - ($0400) Send Error Char when parity error occurs.
11 - ($0800) Discard null bytes.

12 - ($1000) Turn On RTS Line (Always on)
13 - ($2000) Enable RTS Handshaking (False when input buffer full)
     (If both 12 and 13 set, RTS goes true transmitt buffer has chars.)
-----------------------------------------------------------------------

DTE = Data Terminal Equipment - Terminal
DCE = Data Comm Equipment - Modem

(DCE) Modem <---------------------> (DTE) = Terminal
 
PC DB9                                     Terminal DB25
------                                     -------------

RTS   Request To Send       7 -----> 8     CTS   Clear To Send
CTS   Clear To Send         8 <----- 7     RTS   Request To Send

-----------------------------------------------------------------
Half Duplex Communication. Modem controls data transmitted from Computer

TERMINAL SIDE: RTS = Request To Send = Terminal wants to send
TERMINAL SIDE: CTS = From Modem, Indicates Modem is read to receive data

Full Duplex Communication. Both control

MODEM SIDE: RTS = Request To Send = From Modem, Indicates Modem wants to send
MODEM SIDE: CTS = Clear to send = From Terminal - Terminal Ready to receive

-----------------------------------------------------------------

MODEM SIDE:    DSR = Data Set Read = Modem Read to receive
TERMINAL SIDE: DTR = Data Terminal Ready = Terminal ready to receive


CD = Carrier Detect
RI = Ring Indicator


==============================================================================}

type TPortOpenStatus = (poOpened,poClosed,poUnavailable,poNoneSelected,poFailed);

const hbBinary=     $0001; hbParity=       $0002; hbOutCTSFlow=  $0004; hbOutDSRFlow=   $0008;
      hbDTREnabled= $0010; hbDTRHandShake= $0020; hbDSRSense=    $0040; hbXOffContinue= $0080;
      hbXOnOFfTrans=$0100; hbXOnOffReceive=$0200; hbParErrorChar=$0400; hbDiscardNull=  $0800;
      hbRTSEnabled= $1000; hbRTSHandShake= $2000;

type THandShakeFlags = (hfBinary, hfParity, hfOutCTSFlow, hfOutDSRFlow,
		       hfDTREnabled, hfDTRHandShake, hfDSRSense, hfXOffContinue,
		       hfXOnOFfTrans, hfXOnOffReceive, hfParErrorChar, hfDiscardNull,
		       hfRTSEnabled, hfRTSHandShake );


type THandShakeFlag = set of THandShakeFlags;

  TCommEvent=(tceBreak,tceCts,tceCtss,tceDsr,tceErr,tcePErr,
              tceRing,tceRlsd,tceRlsds,tceRxChar,tceRxFlag,
              tceTxEmpty);

  TCommEvents=set of TCommEvent;

const
  PortDefault=tptNone;
  BaudRateDefault=tbr9600;
  ParityDefault=tpNone;
  DataBitsDefault=tdbEight;
  StopBitsDefault=tsbOne;
  ReadBufferSizeDefault=2048;
  WriteBufferSizeDefault=2048;
  EventsDefault=[];

type
  TComThread = class;

  TExceptionClass = class of Exception;

  EComError = class(Exception);
  EOpenComError = class(EComError);

  TNotifyEventEvent= procedure(Sender: TObject; CommEvent: TCommEvents) of object;

  TNotifyReceiveEvent= procedure(Sender:TObject; Count:Word) of object;

  TNotifyTransmitEvent= procedure(Sender: TObject; Count:Word) of object;

  TSerialErrorEvent = procedure(Sender: TObject; Msg: string; var RaiseException: boolean) of object;

  TCommPort=class(TComponent)
  private
    FHWnd: THandle;
    EventThread: TComThread;
    FPort: TSerialPort;
    FBaudRate: TBaudRate;
    FParity: TParity;
    FDataBits: TDataBits;
    FStopBits: TStopBits;
    FHandShake: THandShakeFlag;
    FReadInterval,FReadMultiplier,FReadConstant,
    FWriteMultiplier,FWriteConstant: DWord;
    FReadBufferSize: DWord;
    FWriteBufferSize: DWord;
    FEvents: TCommEvents;
    FOnEvent: TNotifyEventEvent;
    FOnReceive: TNotifyReceiveEvent;
    FOnTransmit: TNotifyTransmitEvent;
    FOnError: TSerialErrorEvent;
    hComm: dword;
    HasBeenLoaded: Boolean;
    EventMask: Word;
    FReadOverLap,FWriteOverLap: TOverlapped;
    HandleBusy: TCriticalSection;
    ResultMask: DWORD;
    FLastStatus: TPortOpenStatus;
    FOnChange: TNotifyEvent;
    procedure SetFlags;
    procedure SetBaudRate;
    procedure SetParity;
    procedure SetDataBits;
    procedure SetStopBits;
    procedure SetEvents;
    procedure SetTimeouts;
    procedure DoEvent;
    procedure DoReceive;
    procedure DoTransmit;
    function GetInputCount: integer;
    procedure SetPortStatus(V: boolean);
    function GetPortStatus: boolean;
    procedure OpenPort;
    procedure ClosePort;
    function GetPortHandle: DWord;
    procedure MessageHandler(var Msg:TMessage);
    procedure HandleError(Msg: string; ExceptionClass: TExceptionClass);
  protected
    procedure SetHandshake(V: THandshakeFlag);
    procedure Change;
  public
    AbortWait: boolean;
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function IsValidPort: boolean;
    function GetComDevice: string;
    function GetComDescription: string;
    procedure SynchronousClose;
    function TestAndOpen: TPortOpenStatus;
    function GetBaudRateValue(B: TBaudRate): dword;
    function ReadText(var Data; BytesToRead: DWord): DWord;
    function ReadString(var S: string; Count: integer): integer;
    function GetString: string;
    function ReadChar: Char;
    function WriteText(var Data; BytesToWrite: Word): DWord;
    procedure WriteString(S: string);
    procedure WriteChar(C: char);
    procedure PurgeBuffer;
    function GetSerialStatus: TPortOpenStatus;
    function WaitForChar(var C: char): boolean;
    property Handle: DWord read hComm;
    property LastStatus: TPortOpenStatus read FLastStatus write FLastStatus;
  published
    property HandShake: THandShakeFlag read FHandShake write SetHandshake default [hfBinary];
    property Port: TSerialPort read FPort write FPort default PortDefault;
    property BaudRate: TBaudRate read FBaudRate write FBaudRate default BaudRateDefault;
    property Parity: TParity read FParity write FParity default ParityDefault;
    property DataBits: TDataBits read FDataBits write FDataBits default DataBitsDefault;
    property StopBits: TStopBits read FStopBits write FStopBits default StopBitsDefault;
    property WriteBufferSize: DWord read FWriteBufferSize write FWriteBufferSize default WriteBufferSizeDefault;
    property ReadBufferSize: DWord read FReadBufferSize write FReadBufferSize default ReadBufferSizeDefault;
    property Events: TCommEvents read FEvents write FEvents default EventsDefault;
    property OnEvent: TNotifyEventEvent read FOnEvent write FOnEvent;
    property OnReceive: TNotifyReceiveEvent read FOnReceive write FOnReceive;
    property OnTransmit: TNotifyTransmitEvent read FOnTransmit write FOnTransmit;
    property OnError: TSerialErrorEvent read FOnError write FOnError;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
    property ReadInterval: dword read FReadInterval write FReadInterval default 0;
    property ReadMultiplier: dword read FReadMultiplier write FReadMultiplier default 0;
    property ReadConstant: dword read FReadConstant write FReadConstant default 0;
    property WriteMultiplier: dword read FWriteMultiplier write FWriteMultiplier default 0;
    property WriteConstant: dword read FWriteConstant write FWriteConstant default 0;
    property InputCount: integer read GetInputCount;
    property PortActive: boolean read GetPortStatus write SetPortStatus;
  end;


TComThread = class(TThread)
 private
  Owner: TCommPort;
  OverEvent: TOverlapped;
 protected
  procedure Execute; override;
  procedure DoEvents;
 public
  constructor Create(AOwner: TCommPort);
  destructor Destroy; override;
 end;

function GetCommEventStr(CE: TCommEvent): string;
function GetCommEventsStr(CE: TCommEvents): string;

function GetCommPortDevice(P: TSerialPort): string;
function GetCommPortDescription(P: TSerialPort): string;
function IsPortAvailable(P: TSerialPort): boolean;
function IndexToPort(Inx: integer): TSerialPort;
function PortToIndex(P: TSerialPort): integer;
procedure SetPortStrings(List: TStrings);
function GetSettingsStr(P: TCommPort): string;
procedure SetBaudStrings(List: TStrings);



procedure Register;


implementation


procedure Register;
begin
RegisterComponents('Fountain',[TCommPort]);
end;



{-------------------- Support Routines ----------------------------------}

function GetCommEventStr(CE: TCommEvent): string;
{Get strings associated with Comm Events Set}
begin
case CE of
 tceBreak: Result:='Break';
 tceCts: Result:='Clear To Send Change';
 tceCtss: Result:='Clear To Send On';
 tceDsr: Result:='Data Set Reader Change';
 tceErr: Result:='Line Status Error';
 tcePErr: Result:='Printer Error';
 tceRing: Result:='Ring';
 tceRlsd: Result:='Carrier Detect';
 tceRlsds: Result:='Data Set Ready On';
 tceRxChar: Result:='Receive Char';
 tceRxFlag: Result:='Special (Evt) Char Received';
 tceTxEmpty: Result:='Transmit Buffer Empty';
 end;
end;




function GetCommEventsStr(CE: TCommEvents): string;
{Get strings associated with Comm Events Set}
begin
Result:='';
if tceBreak in CE then Result:=Result+','+GetCommEventStr(tceBreak);
if tceCts in CE then Result:=Result+','+GetCommEventStr(tceCts);
if tceCtss in CE then Result:=Result+','+GetCommEventStr(tceCtss);
if tceDsr in CE then Result:=Result+','+GetCommEventStr(tceDsr);
if tceErr in CE then Result:=Result+','+GetCommEventStr(tceErr);
if tcePErr in CE then Result:=Result+','+GetCommEventStr(tcePErr);
if tceRing in CE then Result:=Result+','+GetCommEventStr(tceRing);
if tceRlsd in CE then Result:=Result+','+GetCommEventStr(tceRlsd);
if tceRlsds in CE then Result:=Result+','+GetCommEventStr(tceRlsds);
if tceRxChar in CE then Result:=Result+','+GetCommEventStr(tceRxChar);
if tceRxFlag in CE then Result:=Result+','+GetCommEventStr(tceRxFlag);
if tceTxEmpty in CE then Result:=Result+','+GetCommEventStr(tceTxEmpty);
end;





function GetHandshakeBits(Flag: THandshakeFlag): integer;
{Convert Handshake Flag constants Windows constants}
begin
Result:=0;
if hfBinary in Flag then Result:=Result or hbBinary;
if hfParity in Flag then Result:=Result or hbParity;
if hfOutCTSFlow in Flag then Result:=Result or hbOutCTSFlow;
if hfOutDSRFlow in Flag then Result:=Result or hbOutDSRFlow;
if hfDTREnabled in Flag then Result:=Result or hbDTREnabled;
if hfDTRHandShake in Flag then Result:=Result or hbDTRHandShake;
if hfDSRSense in Flag then Result:=Result or hbDSRSense;
if hfXOffContinue in Flag then Result:=Result or hbXOffContinue;
if hfXOnOFfTrans in Flag then Result:=Result or hbXOnOFfTrans;
if hfXOnOffReceive in Flag then Result:=Result or hbXOnOffReceive;
if hfParErrorChar in Flag then Result:=Result or hbParErrorChar;
if hfDiscardNull in Flag then Result:=Result or hbDiscardNull;
if hfRTSEnabled in Flag then Result:=Result or hbRTSEnabled;
if hfRTSHandShake in Flag then Result:=Result or hbRTSHandShake;
end;



function GetHandshakeFlag(Flag: integer): THandshakeFlag;
{Convert Windows constant to my Handshake flag constants}
begin
Result:=[];
if IsBitSet(Flag,hbBinary) then Result:=Result + [hfBinary];
if IsBitSet(Flag,hbParity) then Result:=Result + [hfParity];
if IsBitSet(Flag,hbOutCTSFlow) then Result:=Result + [hfOutCTSFlow];
if IsBitSet(Flag,hbOutDSRFlow) then Result:=Result + [hfOutDSRFlow];
if IsBitSet(Flag,hbDTREnabled) then Result:=Result + [hfDTREnabled];
if IsBitSet(Flag,hbDTRHandShake) then Result:=Result + [hfDTRHandShake];
if IsBitSet(Flag,hbDSRSense) then Result:=Result + [hfDSRSense];
if IsBitSet(Flag,hbXOffContinue) then Result:=Result + [hfXOffContinue];
if IsBitSet(Flag,hbXOnOFfTrans) then Result:=Result + [hfXOnOFfTrans];
if IsBitSet(Flag,hbXOnOffReceive) then Result:=Result + [hfXOnOffReceive];
if IsBitSet(Flag,hbParErrorChar) then Result:=Result + [hfParErrorChar];
if IsBitSet(Flag,hbDiscardNull) then Result:=Result + [hfDiscardNull];
if IsBitSet(Flag,hbRTSEnabled) then Result:=Result + [hfRTSEnabled];
if IsBitSet(Flag,hbRTSHandShake) then Result:=Result + [hfRTSHandShake];
end;



function GetCommPortDescription(P: TSerialPort): string;
{Get commport description name}
var N: integer;
begin
if P=tptNone then Result:='None'
else
	begin
	N:=integer(P)+1;
	Result:='Com'+IntToStr(N);
	end;
end;


function GetSettingsStr(P: TCommPort): string;
{Returns short-form description of the port settings}
{In the format of: Port:Parity:Data Bits:Stop Bits}
begin
Result:=P.GetComDescription;
Result:=Result+': '+BaudRateStrs[Integer(P.BaudRate)];
Result:=Result+' '+ParityStrs[Integer(P.Parity)];
Result:=Result+':'+DataBitStrs[Integer(P.DataBits)];
Result:=Result+':'+StopBitStrs[Integer(P.StopBits)];
end;


function GetCommPortDevice(P: TSerialPort): string;
{Get commport device name}
begin
Result:=GetCommPortDescription(P);
if P=tptNone then exit;
if (integer(P)+1)>9 then Result:='\\.\'+Result;
end;



function IsPortAvailable(P: TSerialPort): boolean;
{ Return true if specified port is available.}
{Port is specified by number i.e. 0=COM1}
var Port: string;
var hComm: dword;
begin
Port:=GetCommPortDevice(P);
hComm:=CreateFile(PChar(Port),GENERIC_READ or GENERIC_WRITE,0,nil, OPEN_EXISTING,FILE_FLAG_OVERLAPPED,0);
Result:=hComm<>INVALID_HANDLE_VALUE;
if Result then CloseHandle(hComm);
end;




{Routines for setting up ListBoxes and ComboBoxes for serial ports}

function IndexToPort(Inx: integer): TSerialPort;
{Convert string index to port constant}
begin
if (Inx<0) or (Inx>=MaxCommPorts) then  raise Exception.Create('Invalide Serial Port Index');
Result:=TSerialPort(Inx);
end;


function PortToIndex(P: TSerialPort): integer;
{Convert port constant to list index}
begin
Result:=Integer(P);
end;


procedure SetPortStrings(List: TStrings);
{Fill TString object with port names/descriptions}
var I: integer;
begin
List.Clear;
for I:=0 to MaxCommPorts-1 do
	List.Add(GetCommPortDescription(IndexToPort(I)));
end;


{------------------------------------------------------------------------}



procedure SetBaudStrings(List: TStrings);
{Fill TString object with port names/descriptions}
var I: integer;
begin
List.Clear;
for I:=0 to MaxBaudRates-1 do
	List.Add(BaudRateStrs[I]);
end;



{-------------------Thread to monitor the the serial port ---------------}


constructor TComThread.Create(AOwner: TCommPort);
begin
inherited Create(True);
Owner:= AOwner;
Priority:= tpTimeCritical;
Resume;
end;



procedure TComThread.Execute;
var  Status: Boolean;
var Count: DWord;


	function WaitForPending: boolean;
	var R: DWord;
	begin
	while not Terminated do
		begin
		R:=WaitForSingleObject(OverEvent.hEvent, 1);
		case R of
		 WAIT_OBJECT_0:
			begin
			GetOverlappedResult(Owner.hComm, OverEvent, Count, True);
			if Owner.ResultMask <> 0 then DoEvents;
			Result:=True;
			break;
			end;
		 WAIT_TIMEOUT:
			begin
			Application.ProcessMessages;
			Result:=not Application.Terminated;
			end;
		 WAIT_FAILED: Result:=False;
		 WAIT_ABANDONED: Result:=False;
		 else Result:=True;
		 end;
		if not Result then break;
		end;
	end;

begin
if Owner.EventMask=0 then exit;
SetCommMask(Owner.hComm,Owner.EventMask);
OverEvent.hEvent:=CreateEvent(nil, True, False, nil);
repeat
	begin
	Owner.ResultMask:=0;
	Status:=WaitCommEvent(Owner.hComm, Owner.ResultMask,@OverEvent);
	if not Status then
		begin
		case GetLastError of
                 ERROR_INVALID_HANDLE: break;
		 ERROR_IO_PENDING: WaitForPending;
		 else Sleep(1);
		 end;
		end;
	end
until Terminated;
CloseHandle(OverEvent.hEvent);
end;



destructor TComThread.Destroy;
begin
Terminate;
if Owner.hComm<>INVALID_HANDLE_VALUE then SetCommMask(Owner.hComm, 0);
inherited Destroy;
end;


procedure TComThread.DoEvents;
begin
{Note: Events handled through "PostMessage" so the Comm Thread doesn't block}
if boolean(Owner.ResultMask and (EV_ERR or EV_BREAK or EV_RING or EV_CTS or EV_DSR or EV_RLSD)) then PostMessage(Owner.FHwnd,WM_SerialEvent,0,0);
if boolean(EV_RXCHAR and Owner.ResultMask) then PostMessage(Owner.FHwnd,WM_SerialReceive,0,0);
if boolean(EV_TXEMPTY and Owner.ResultMask) then PostMessage(Owner.FHwnd,WM_SerialTransmit,0,0);
end;

{-------------------- Error handling routines ---------------------------}


procedure TCommPort.HandleError(Msg: string; ExceptionClass: TExceptionClass);
var RaiseException: boolean;
begin
RaiseException:=True;
if Assigned(FOnError) then FOnError(Self,Msg,RaiseException);
if RaiseException then raise ExceptionClass.Create(Msg)
else Abort;
end;



{-------------------Routines to setup serial port ----------------------}


function TCommPort.GetBaudRateValue(B: TBaudRate): dword;
{Get Windows baud rate value, which is also the numerical baud reate}
begin
case B of
 tbr110: Result:=CBR_110;
 tbr300: Result:=CBR_300;
 tbr600: Result:=CBR_600;
 tbr1200: Result:=CBR_1200;
 tbr2400: Result:=CBR_2400;
 tbr4800: Result:=CBR_4800;
 tbr9600: Result:=CBR_9600;
 tbr14400: Result:=CBR_14400;
 tbr19200: Result:=CBR_19200;
 tbr38400: Result:=CBR_38400;
 tbr56000: Result:=CBR_56000;
 tbr57600: Result:=CBR_57600;
 tbr115200: Result:=CBR_115200;
 tbr128000: Result:=CBR_128000;
 tbr256000: Result:=CBR_256000;
 tbr230400: Result:=CBR_230400;
 tbr460800: Result:=CBR_460800;
 tbr500000: Result:=CBR_500000;
 tbr512000: Result:=CBR_512000;
 tbr921600: Result:=CBR_921600;
 tbr1000000: Result:=CBR_1000000;
 tbr1024000: Result:=CBR_1024000;
 tbr1500000: Result:=CBR_1500000;
 tbr2000000: Result:=CBR_2000000;
 tbr2500000: Result:=CBR_2500000;
 else Result:=CBR_9600;
 end;
end;




procedure TCommPort.SetFlags;
var DCB: TDCB;
begin
if hComm=INVALID_HANDLE_VALUE then exit;
GetCommState(hComm,DCB);
DCB.Flags:=GetHandshakeBits(FHandshake);
SetCommState(hComm,DCB);
Change;
end;



procedure TCommPort.SetBaudRate;
var DCB: TDCB;
begin
if hComm=INVALID_HANDLE_VALUE then exit;
GetCommState(hComm,DCB);
DCB.BaudRate:=GetBaudRateValue(FBaudRate);
SetCommState(hComm,DCB);
Change;
end;



procedure TCommPort.SetParity;
var DCB: TDCB;
begin
if hComm=INVALID_HANDLE_VALUE then exit;
GetCommState(hComm,DCB);
case FParity of
 tpNone: DCB.Parity:=0;
 tpOdd:  DCB.Parity:=1;
 tpEven: DCB.Parity:=2;
 tpMark: DCB.Parity:=3;
 tpSpace: DCB.Parity:=4;
 end;
SetCommState(hComm,DCB);
Change;
end;


procedure TCommPort.SetDataBits;
var DCB: TDCB;
begin
if hComm=INVALID_HANDLE_VALUE then exit;
GetCommState(hComm,DCB);
case FDataBits of
 tdbFour: DCB.ByteSize:=4;
 tdbFive: DCB.ByteSize:=5;
 tdbSix:  DCB.ByteSize:=6;
 tdbSeven: DCB.ByteSize:=7;
 tdbEight: DCB.ByteSize:=8;
 end;
SetCommState(hComm,DCB);
Change;
end;


procedure TCommPort.SetStopBits;
var DCB: TDCB;
begin
if hComm=INVALID_HANDLE_VALUE then exit;
GetCommState(hComm,DCB);
case FStopBits of
 tsbOne: DCB.StopBits:=0;
 tsbOnePointFive: DCB.StopBits:=1;
 tsbTwo: DCB.StopBits:=2;
 end;
SetCommState(hComm,DCB);
Change;
end;


procedure TCommPort.SetEvents;
begin
if hComm=INVALID_HANDLE_VALUE then exit;
EventMask:=0;
if tceBreak in FEvents then inc(EventMask,EV_BREAK);
if tceCts in FEvents then inc(EventMask,EV_CTS);
if tceDsr in FEvents then inc(EventMask,EV_DSR);
if tceErr in FEvents then inc(EventMask,EV_ERR);
if tcePErr in FEvents then inc(EventMask,EV_PERR);
if tceRing in FEvents then inc(EventMask,EV_RING);
if tceRlsd in FEvents then inc(EventMask,EV_RLSD);
if tceRxChar in FEvents then inc(EventMask,EV_RXCHAR);
if tceRxFlag in FEvents then inc(EventMask,EV_RXFLAG);
if tceTxEmpty in FEvents then inc(EventMask,EV_TXEMPTY);
Change;
end;



procedure TCommPort.SetTimeouts;
var Timeouts: TCommTimeouts;
begin
GetCommTimeouts(hComm, Timeouts);

Timeouts.ReadIntervalTimeout:= FReadInterval;
Timeouts.ReadTotalTimeoutMultiplier:= FReadMultiplier;
Timeouts.ReadTotalTimeoutConstant:= FReadConstant;

Timeouts.WriteTotalTimeoutMultiplier:= FWriteMultiplier;
Timeouts.WriteTotalTimeoutConstant:= FWriteConstant;
SetCommTimeouts(hComm, Timeouts);
Change;
end;

{------------------Property Access routines ---------------------------------}

function TCommPort.GetInputCount: integer;
var Stat: TComStat;
var Errors: DWord;
begin
Result:=0;
if hComm=INVALID_HANDLE_VALUE then exit;
if not ClearCommError(hComm,Errors,@Stat) then exit;
Result:=Stat.cbInQue;
end;



procedure TCommPort.ClosePort;
{Windows Documentation says that the port may take two seconds to shutdown}
begin
if hComm<>INVALID_HANDLE_VALUE then
	begin
	HandleBusy.Acquire;
	try
	if CloseHandle(hComm) then hComm:=INVALID_HANDLE_VALUE;
	finally
	 HandleBusy.Release;
	 EventThread.Free;
	 end;
	end;
end;



procedure TCommPort.SynchronousClose;
{Close commport and wait for it to be free}
var I: integer;
const TimeOut = 200;
const Increment = 10;
begin
if not PortActive then exit;
PortActive:=False;
for I:=1 to TimeOut div Increment do
	begin
	if IsPortAvailable(Port) then exit;
	Sleep(Increment);
	end;
end;



function TCommPort.GetComDevice: string;
begin
Result:=GetCommPortDevice(FPort);
end;



function TCommPort.GetComDescription: string;
begin
Result:=GetCommPortDescription(FPort);
end;



function TCommPort.GetPortHandle: DWord;
begin
Result:=CreateFile(PChar(GetComDevice), GENERIC_READ or GENERIC_WRITE,
	0,nil, OPEN_EXISTING, FILE_FLAG_OVERLAPPED, 0);
end;


procedure TCommPort.OpenPort;
begin
if (csDesigning in ComponentState) or (FPort=tptNone) then exit;
ClosePort;
hComm:=GetPortHandle;
if hComm=INVALID_HANDLE_VALUE then HandleError('Could not open '+GetComDescription, EOpenComError);

if not SetupComm(hComm,ReadBufferSize,WriteBufferSize) then HandleError(SysErrorMessage(GetLastError),EOpenComError);

SetFlags;
SetBaudRate;
SetParity;
SetDataBits;
SetStopBits;
SetEvents;
SetTimeouts;
EventThread:= TComThread.Create(Self);
end;


function TCommPort.GetPortStatus: boolean;
begin
Result:=hComm<>INVALID_HANDLE_VALUE;
end;



procedure TCommPort.SetPortStatus(V: boolean);
begin
if V<>GetPortStatus then
 if V then OpenPort else ClosePort;
Change;
end;



function TCommPort.GetSerialStatus: TPortOpenStatus;
begin
if PortActive then Result:=poOpened
else if Port=tptNone then Result:=poNoneSelected
else if not IsPortAvailable(Port) then Result:=poUnavailable
else Result:=poClosed;
end;




function TCommPort.TestAndOpen: TPortOpenStatus;
begin
Result:=poOpened;
if Port=tptNone then Result:=poNoneSelected
else if not IsPortAvailable(Port) then Result:=poUnavailable
else
	begin
	try
	PortActive:=True;
	except Result:=poFailed; end;
	end;
end;



{----------------Event handlers -----------------------------------}


constructor TCommPort.Create(AOwner:TComponent);
begin
inherited Create(AOwner);
FHWnd := Classes.AllocateHWnd(MessageHandler);
HandleBusy:=TCriticalSection.Create;
HasBeenLoaded:=False;
FPort:=PortDefault;
FBaudRate:=BaudRateDefault;
FParity:=ParityDefault;
FDataBits:=DataBitsDefault;
FStopBits:=StopBitsDefault;
FWriteBufferSize:=WriteBufferSizeDefault;
FReadBufferSize:=ReadBufferSizeDefault;
FEvents:=EventsDefault;
hComm:=INVALID_HANDLE_VALUE;
FReadOverLap.hEvent:= CreateEvent(Nil, True, False, Nil);
FWriteOverLap.hEvent:= CreateEvent(Nil, True, False, Nil);
FHandshake:=[hfBinary,hfDTREnabled];
end;



destructor TCommPort.Destroy;
begin
ClosePort;
CloseHandle(FReadOverLap.hEvent );
CloseHandle(FWriteOverLap.hEvent );
HandleBusy.Free;
Classes.DeallocateHWnd(FHWnd);
inherited Destroy;
end;


{------------------ Handle events generated by the thread ------------}

procedure TCommPort.DoEvent;
var CommEvent:TCommEvents;
var ModemStat: DWord;
begin
if (hComm=INVALID_HANDLE_VALUE) or not Assigned(FOnEvent) then exit;
GetCommModemStatus(hComm,ModemStat);
CommEvent:=[];

if (tceCtss in Events) and (ModemStat and MS_CTS_ON<>0) then CommEvent:=CommEvent+[tceCtss];
if (tceRlsds in Events) and (ModemStat and MS_DSR_ON<>0) then CommEvent:=CommEvent+[tceRlsds];

if (tceBreak in Events) and (EventMask and EV_BREAK<>0) then CommEvent:=CommEvent+[tceBreak];
if (tceCts in Events) and (EventMask and EV_CTS<>0) then CommEvent:=CommEvent+[tceCts];
if (tceDsr in Events) and (EventMask and EV_DSR<>0) then CommEvent:=CommEvent+[tceDsr];
if (tceErr in Events) and (EventMask and EV_ERR<>0) then CommEvent:=CommEvent+[tceErr];
if (tcePErr in Events) and (EventMask and EV_PERR<>0) then CommEvent:=CommEvent+[tcePErr];
if (tceRing in Events) and (EventMask and EV_RING<>0) then CommEvent:=CommEvent+[tceRing];
if (tceRlsd in Events) and (EventMask and EV_RLSD<>0) then CommEvent:=CommEvent+[tceRlsd];
if (tceRxChar in Events) and (EventMask and EV_RXCHAR<>0) then CommEvent:=CommEvent+[tceRxChar];
if (tceRxFlag in Events) and (EventMask and EV_RXFLAG<>0) then CommEvent:=CommEvent+[tceRxFlag];
if (tceTxEmpty in Events) and (EventMask and EV_TXEMPTY<>0) then CommEvent:=CommEvent+[tceTxEmpty];
FOnEvent(Self,CommEvent);
end;



procedure TCommPort.DoReceive;
var Count: integer;
begin
if (hComm=INVALID_HANDLE_VALUE) or not Assigned(FOnReceive) then exit;
Count:=GetInputCount;
if Count=0 then exit;
FOnReceive(Self,Count);
end;



procedure TCommPort.DoTransmit;
begin
if (hComm=INVALID_HANDLE_VALUE) or not Assigned(FOnTransmit) then exit;
FOnTransmit(Self,GetInputCount);
end;


procedure TCommPort.MessageHandler(var Msg:TMessage);
begin
case Msg.Msg of
 WM_SerialReceive: DoReceive;
 WM_SerialTransmit: DoTransmit;
 WM_SerialEvent: DoEvent;
 end;
end;


{----------------Information Gathering Methods ---------------------}


function  TCommPort.IsValidPort: boolean;
var H: DWord;
begin
H:=GetPortHandle;
Result:=H<>INVALID_HANDLE_VALUE;
if Result then CloseHandle(H);
end;


{-------------------Handle Output Routines -----------------}



function TCommPort.WriteText(var Data; BytesToWrite:Word): DWord;
begin
if hComm=INVALID_HANDLE_VALUE then exit;

if not WriteFile(hComm,Data,BytesToWrite,Result,@FWriteOverLap) then
	if GetLastError = ERROR_IO_PENDING then
		begin
		{Use Wait Object to handle timeout for CTS/RTS and other types of flow control}
		if WaitForSingleObject(FWriteOverLap.hEvent,WriteMultiplier*BytesToWrite+FWriteConstant)=WAIT_FAILED then Result:=0
		else
			begin
			GetOverlappedResult(hComm, FWriteOverLap, Result, False );
			FWriteOverLap.Offset :=FWriteOverLap.Offset+Result;
			end;
		end
	else HandleError('Write Error.',Exception);
end;


procedure TCommPort.WriteString(S: string);
begin
WriteText(S[1],Length(S));
end;


procedure TCommPort.WriteChar(C: char);
var S: string;
begin
S:=C;
WriteString(S);
end;

{-------------------Low Level Read Routines -----------------}



function TCommPort.ReadText(var Data; BytesToRead: DWord): DWord;
{Read text with specified timeout}
var Error: DWord;
var RStatus: boolean;

	function WaitForText: DWord;
	{Wait for text - Timeout after specified time }
	{Returns number of }
	var R: DWord;
	begin
	Result:=0;
	AbortWait:=False;
	while not AbortWait do
		begin
		R:=WaitForSingleObject(FReadOverLap.hEvent, 100);
		case R of
		 WAIT_OBJECT_0:
			begin
			GetOverlappedResult(hComm,FReadOverLap,Result,False);
			break;
			end;
		 WAIT_FAILED: HandleError('Read Error.',Exception);
		 WAIT_ABANDONED: abort;
		 WAIT_TIMEOUT:
			begin
			Application.ProcessMessages;
			if Application.Terminated then abort;
			end;
		 end;
		end;
	end;


begin
Result:=0;
HandleBusy.Acquire;
try
if hComm=INVALID_HANDLE_VALUE then abort;
RStatus:=ReadFile(hComm,Data,BytesToRead,Result,@FReadOverLap);
finally HandleBusy.Release; end;

{if no data is available, wait for input}
if not RStatus then
	begin
        Error:=GetLastError;
	if Error = ERROR_IO_PENDING then Result:=WaitForText
	else HandleError('Read Error.',Exception);
	{Note: data is automatically stored in Data after}
	{ wait completes even without recalling ReadFile.}
	end;
end;


{------------------ Higher Level Read Routines -------------------------------}

function TCommPort.ReadString(var S: string; Count: integer): integer;
begin
SetLength(S,Count);
Result:=ReadText(S[1],Count);
SetLength(S,Result);
end;


function TCommPort.GetString: string;
var Count: integer;
begin
Result:='';
Count:=GetInputCount;
if Count<>0 then ReadString(Result,Count);
end;



function TCommPort.ReadChar: Char;
var S: string;
begin
if ReadString(S,1)>0 then Result:=S[1]
else Result:=#0;
end;


function TCommPort.WaitForChar(var C: Char): boolean;
{Wait for character. If timeouts not zero, will timeout}
{ if characters not received with specified time. Returns }
{false if the routine times out before receiving a character}
var Count: integer;
begin
Result:=False;
if not PortActive then HandleError('Port Not Active',EOpenComError);
Count:=ReadText(C,1);
Result:=Count>0;
end;



procedure TCommPort.SetHandshake(V: THandshakeFlag);
begin
if Self.FHandShake<> V then
	begin
	FHandshake:=V;
	SetFlags;
	end;
end;



procedure TCommPort.Change;
begin
if Assigned(FOnChange) then FOnChange(Self);
end;



procedure TCommPort.PurgeBuffer;
begin
PurgeComm(hComm, PURGE_RXABORT or PURGE_RXCLEAR);
end;



end.
