unit LinkLabel;

interface

uses
  Windows, Messages, SysUtils, Forms, Classes, Controls, StdCtrls, Graphics, NetLib;

type
  TWebLinkLabel = class(TLabel)
  private
    procedure HandleLabelLink(Sender: TObject);
  protected
  public
    constructor Create(AOwner: TComponent); override;
  published
  end;

{Note: the word Register must have upper case R or it won't Register}

procedure Register;

implementation

uses ShellAPI;

procedure Register;
begin
RegisterComponents('Fountain', [TWebLinkLabel]);
end;



procedure TWebLinkLabel.HandleLabelLink(Sender: TObject);
{Use label as email or web link. Expects to }
{find the link or email address in the hint}
{Email addresses should have "mailto:" in front of the address}
{and web links should have "http:" in front of the link.}
begin
If (Sender is TLabel) then BrowseURL(TLabel(Sender).Hint);
end;



constructor TWebLinkLabel.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
Font.Color:=clBlue;
Font.Style:=[fsUnderline];
OnClick:=HandleLabelLink;
Hint:='http://fountainware.com';
Caption:='http://fountainware.com';
Cursor:=crHandPoint;
end;


end.
