unit PaintBoxEx;

interface

uses Messages,Graphics,Classes,Controls;


type TPaintBoxEx = class(TCustomControl)
  private
    FOnPaint: TNotifyEvent;
    FEraseBackground: boolean;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X,Y: Integer); override;
  protected
    procedure StopFlicker(var Msg: TWMEraseBkgnd); message WM_ERASEBKGND;
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
    property Canvas;
    property EraseBackground: boolean read FEraseBackground write FEraseBackground;
    property MouseCapture;
  published
    property OnKeyPress;
    property OnKeyDown;
    property OnKeyUp;
    property TabOrder;
    property TabStop;

    property Align;
    property Anchors;
    property Color;
    property Constraints;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property Visible;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnPaint: TNotifyEvent read FOnPaint write FOnPaint;
    property OnStartDock;
    property OnStartDrag;
  end;

procedure Register;


implementation


procedure Register;
begin
RegisterComponents('Fountain', [TPaintBoxEx]);
end;

procedure TPaintBoxEx.MouseDown(Button: TMouseButton; Shift: TShiftState; X,  Y: Integer);
begin
inherited;
{ Focus the control when it is clicked.}
if not (csDesigning in ComponentState) and CanFocus then SetFocus;
end;



procedure TPaintBoxEx.StopFlicker(var Msg: TWMEraseBkgnd);
begin
if FEraseBackground then inherited else Msg.Result := 1;
end;


constructor TPaintBoxEx.Create(AOwner: TComponent);
begin
inherited Create(AOwner);
ControlStyle := ControlStyle + [csReplicatable];
ControlStyle := ControlStyle + [csOpaque];
Width := 105;
Height := 105;
FEraseBackground:=True;
end;



procedure TPaintBoxEx.Paint;
begin
Canvas.Font := Font;
Canvas.Brush.Color := Color;
if csDesigning in ComponentState then
 with Canvas do
	begin
	Pen.Style := psDash;
	Brush.Style := bsClear;
	Rectangle(0, 0, Width, Height);
	end;
if Assigned(FOnPaint) then FOnPaint(Self);
end;


end.
