unit paintpan;

interface

uses Windows,ExtCtrls,Classes,Controls,Messages;

type TPaintPanel=class(TCustomPanel)
  private
    FOnPaint: TNotifyEvent;
    function GetHDC: HDC;
  protected
    procedure Paint; override;
   public
    property Canvas;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer); override;
    procedure CMMouseEnter(var Message: TMessage); message CM_MOUSEENTER;
  published
    property DC: HDC read GetHDC;
    property OnPaint: TNotifyEvent read FOnPaint write FOnPaint;
    property Align;
    property Alignment;
    property Anchors;
    property BevelInner;
    property BevelOuter;
    property BevelWidth;
    property BorderWidth;
    property BorderStyle;
    property DragCursor;
    property DragMode;
    property Enabled;
    property FullRepaint;
    property Caption;
    property Color;
    property Ctl3D;
    property Font;
    property Locked;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnMouseWheel;
    property OnMouseWheelDown;
    property OnMouseWheelUp;
    property OnResize;
    property OnStartDrag;
end;

procedure Register;

implementation


procedure Register;
begin
RegisterComponents('Fountain', [TPaintPanel]);
end;


procedure TPaintPanel.CMMouseEnter(var Message: TMessage);
begin
{I'm not sure why this was used, but setting focus
resets scroll bars on a containing scrollbox}
//SetFocus;
end;

function TPaintPanel.GetHDC: HDC;
begin
Result:=GetDC(Handle);
end;

procedure TPaintPanel.MouseDown(Button: TMouseButton; Shift: TShiftState;
  X, Y: Integer);
begin
  inherited;
SetFocus;

end;

procedure TPaintPanel.MouseMove(Shift: TShiftState; X, Y: Integer);
begin
  inherited;

end;

procedure TPaintPanel.MouseUp(Button: TMouseButton; Shift: TShiftState; X,
  Y: Integer);
begin
  inherited;
SetFocus;

end;

procedure TPaintPanel.Paint;
begin
if Assigned(FOnPaint) then FOnPaint(Self);
end;




end.


 